

' VBA declare statements for NAG Fortran Library DLL Mark 29.3
' Copyright 2023, Numerical Algorithms Group Ltd, Oxford, UK.
' chapter d01

' skeleton code for callback function
'  Function D01AHF_F( _
'      ByRef x As double _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Function D01AHF Lib "NLW32293E_nag.dll" ( _
    ByRef a As double, _
    ByRef b As double, _
    ByRef epsr As double, _
    ByRef npts As long, _
    ByRef relerr As double, _
    ByVal f As longPtr, _
    ByRef nlimit As long, _
    ByRef ifail As long _
   ) As double


' skeleton code for callback function
'  Function D01AJF_F( _
'      ByRef x As double _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub D01AJF Lib "NLW32293E_nag.dll" ( _
    ByVal f As longPtr, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef epsabs As double, _
    ByRef epsrel As double, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef w As double, _
    ByRef lw As long, _
    ByRef iw As long, _
    ByRef liw As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Function D01AKF_F( _
'      ByRef x As double _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub D01AKF Lib "NLW32293E_nag.dll" ( _
    ByVal f As longPtr, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef epsabs As double, _
    ByRef epsrel As double, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef w As double, _
    ByRef lw As long, _
    ByRef iw As long, _
    ByRef liw As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Function D01ALF_F( _
'      ByRef x As double _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub D01ALF Lib "NLW32293E_nag.dll" ( _
    ByVal f As longPtr, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef npts As long, _
    ByRef points As double, _
    ByRef epsabs As double, _
    ByRef epsrel As double, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef w As double, _
    ByRef lw As long, _
    ByRef iw As long, _
    ByRef liw As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Function D01AMF_F( _
'      ByRef x As double _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub D01AMF Lib "NLW32293E_nag.dll" ( _
    ByVal f As longPtr, _
    ByRef bound As double, _
    ByRef inf As long, _
    ByRef epsabs As double, _
    ByRef epsrel As double, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef w As double, _
    ByRef lw As long, _
    ByRef iw As long, _
    ByRef liw As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Function D01ANF_G( _
'      ByRef x As double _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub D01ANF Lib "NLW32293E_nag.dll" ( _
    ByVal g As longPtr, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef omega As double, _
    ByRef key As long, _
    ByRef epsabs As double, _
    ByRef epsrel As double, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef w As double, _
    ByRef lw As long, _
    ByRef iw As long, _
    ByRef liw As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Function D01APF_G( _
'      ByRef x As double _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub D01APF Lib "NLW32293E_nag.dll" ( _
    ByVal g As longPtr, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef alfa As double, _
    ByRef beta As double, _
    ByRef key As long, _
    ByRef epsabs As double, _
    ByRef epsrel As double, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef w As double, _
    ByRef lw As long, _
    ByRef iw As long, _
    ByRef liw As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Function D01AQF_G( _
'      ByRef x As double _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub D01AQF Lib "NLW32293E_nag.dll" ( _
    ByVal g As longPtr, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef c As double, _
    ByRef epsabs As double, _
    ByRef epsrel As double, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef w As double, _
    ByRef lw As long, _
    ByRef iw As long, _
    ByRef liw As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Function D01ARF_F( _
'      ByRef x As double _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub D01ARF Lib "NLW32293E_nag.dll" ( _
    ByRef a As double, _
    ByRef b As double, _
    ByVal f As longPtr, _
    ByRef relacc As double, _
    ByRef absacc As double, _
    ByRef maxrul As long, _
    ByRef iparm As long, _
    ByRef acc As double, _
    ByRef ans As double, _
    ByRef n As long, _
    ByRef alpha As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Function D01ASF_G( _
'      ByRef x As double _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub D01ASF Lib "NLW32293E_nag.dll" ( _
    ByVal g As longPtr, _
    ByRef a As double, _
    ByRef omega As double, _
    ByRef key As long, _
    ByRef epsabs As double, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef limlst As long, _
    ByRef lst As long, _
    ByRef erlst As double, _
    ByRef rslst As double, _
    ByRef ierlst As long, _
    ByRef w As double, _
    ByRef lw As long, _
    ByRef iw As long, _
    ByRef liw As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D01ATF_F( _
'      ByVal x_rptr As longPtr, _
'      ByVal fv_rptr As longPtr, _
'      ByRef n As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D01ATF Lib "NLW32293E_nag.dll" ( _
    ByVal f As longPtr, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef epsabs As double, _
    ByRef epsrel As double, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef w As double, _
    ByRef lw As long, _
    ByRef iw As long, _
    ByRef liw As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D01AUF_F( _
'      ByVal x_rptr As longPtr, _
'      ByVal fv_rptr As longPtr, _
'      ByRef n As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D01AUF Lib "NLW32293E_nag.dll" ( _
    ByVal f As longPtr, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef key As long, _
    ByRef epsabs As double, _
    ByRef epsrel As double, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef w As double, _
    ByRef lw As long, _
    ByRef iw As long, _
    ByRef liw As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D01BCF Lib "NLW32293E_nag.dll" ( _
    ByRef itype As long, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef c As double, _
    ByRef d As double, _
    ByRef n As long, _
    ByRef weight As double, _
    ByRef abscis As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Function D01BDF_F( _
'      ByRef x As double _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub D01BDF Lib "NLW32293E_nag.dll" ( _
    ByVal f As longPtr, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef epsabs As double, _
    ByRef epsrel As double, _
    ByRef result As double, _
    ByRef abserr As double _
   )


' skeleton code for callback function
'  Function D01DAF_PHI1( _
'      ByRef y As double _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function D01DAF_PHI2( _
'      ByRef y As double _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function D01DAF_F( _
'      ByRef x As double, _
'      ByRef y As double _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub D01DAF Lib "NLW32293E_nag.dll" ( _
    ByRef ya As double, _
    ByRef yb As double, _
    ByVal phi1 As longPtr, _
    ByVal phi2 As longPtr, _
    ByVal f As longPtr, _
    ByRef absacc As double, _
    ByRef ans As double, _
    ByRef npts As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D01EAF_FUNSUB( _
'      ByRef ndim As long, _
'      ByVal z_rptr As longPtr, _
'      ByRef nfun As long, _
'      ByVal f_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D01EAF Lib "NLW32293E_nag.dll" ( _
    ByRef ndim As long, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef mincls As long, _
    ByRef maxcls As long, _
    ByRef nfun As long, _
    ByVal funsub As longPtr, _
    ByRef absreq As double, _
    ByRef relreq As double, _
    ByRef lenwrk As long, _
    ByRef wrkstr As double, _
    ByRef finest As double, _
    ByRef absest As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D01ESF_F( _
'      ByRef ni As long, _
'      ByRef ndim As long, _
'      ByRef nx As long, _
'      ByRef xtr As double, _
'      ByRef nntr As long, _
'      ByVal icolzp_iptr As longPtr, _
'      ByVal irowix_iptr As longPtr, _
'      ByVal xs_rptr As longPtr, _
'      ByVal qs_iptr As longPtr, _
'      ByVal fm_rptr As longPtr, _
'      ByRef iflag As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D01ESF Lib "NLW32293E_nag.dll" ( _
    ByRef ni As long, _
    ByRef ndim As long, _
    ByVal f As longPtr, _
    ByRef maxdlv As long, _
    ByRef dinest As double, _
    ByRef errest As double, _
    ByRef ivalid As long, _
    ByRef iopts As long, _
    ByRef opts As double, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Function D01FBF_F( _
'      ByRef ndim As long, _
'      ByVal x_rptr As longPtr _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Function D01FBF Lib "NLW32293E_nag.dll" ( _
    ByRef ndim As long, _
    ByRef nptvec As long, _
    ByRef lwa As long, _
    ByRef weight As double, _
    ByRef abscis As double, _
    ByVal f As longPtr, _
    ByRef ifail As long _
   ) As double


' skeleton code for callback function
'  Function D01FCF_F( _
'      ByRef ndim As long, _
'      ByVal z_rptr As longPtr _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub D01FCF Lib "NLW32293E_nag.dll" ( _
    ByRef ndim As long, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef minpts As long, _
    ByRef maxpts As long, _
    ByVal f As longPtr, _
    ByRef eps As double, _
    ByRef acc As double, _
    ByRef lenwrk As long, _
    ByRef wrkstr As double, _
    ByRef finval As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Function D01FDF_F( _
'      ByRef ndim As long, _
'      ByVal x_rptr As longPtr _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Sub D01FDF_REGION( _
'      ByRef ndim As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef j As long, _
'      ByRef c As double, _
'      ByRef d As double _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D01FDV Lib "NLW32293E_nag.dll" ( _
    ByRef ndim As long, _
    ByVal x_rptr As longPtr, _
    ByRef j As long, _
    ByRef c As double, _
    ByRef d As double _
  )

   Declare Ptrsafe Sub D01FDF Lib "NLW32293E_nag.dll" ( _
    ByRef ndim As long, _
    ByVal f As longPtr, _
    ByRef sigma As double, _
    ByVal region As longPtr, _
    ByRef limit As long, _
    ByRef r0 As double, _
    ByRef u As double, _
    ByRef result As double, _
    ByRef ncalls As long, _
    ByRef ifail As long _
   )




   Declare Ptrsafe Sub D01GAF Lib "NLW32293E_nag.dll" ( _
    ByRef x As double, _
    ByRef y As double, _
    ByRef n As long, _
    ByRef ans As double, _
    ByRef er As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Function D01GBF_F( _
'      ByRef ndim As long, _
'      ByVal x_rptr As longPtr _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub D01GBF Lib "NLW32293E_nag.dll" ( _
    ByRef ndim As long, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef mincls As long, _
    ByRef maxcls As long, _
    ByVal f As longPtr, _
    ByRef eps As double, _
    ByRef acc As double, _
    ByRef lenwrk As long, _
    ByRef wrkstr As double, _
    ByRef finest As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Function D01GCF_F( _
'      ByRef ndim As long, _
'      ByVal x_rptr As longPtr _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Sub D01GCF_REGION( _
'      ByRef ndim As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef j As long, _
'      ByRef c As double, _
'      ByRef d As double _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D01GCF Lib "NLW32293E_nag.dll" ( _
    ByRef ndim As long, _
    ByVal f As longPtr, _
    ByVal region As longPtr, _
    ByRef npts As long, _
    ByRef vk As double, _
    ByRef nrand As long, _
    ByRef itrans As long, _
    ByRef res As double, _
    ByRef err As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D01GDF_VECFUN( _
'      ByRef ndim As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal fv_rptr As longPtr, _
'      ByRef m As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D01GDF_VECREG( _
'      ByRef ndim As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef j As long, _
'      ByVal c_rptr As longPtr, _
'      ByVal d_rptr As longPtr, _
'      ByRef m As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D01GDF Lib "NLW32293E_nag.dll" ( _
    ByRef ndim As long, _
    ByVal vecfun As longPtr, _
    ByVal vecreg As longPtr, _
    ByRef npts As long, _
    ByRef vk As double, _
    ByRef nrand As long, _
    ByRef itrans As long, _
    ByRef res As double, _
    ByRef err As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D01GYF Lib "NLW32293E_nag.dll" ( _
    ByRef ndim As long, _
    ByRef npts As long, _
    ByRef vk As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D01GZF Lib "NLW32293E_nag.dll" ( _
    ByRef ndim As long, _
    ByRef np1 As long, _
    ByRef np2 As long, _
    ByRef vk As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Function D01JAF_F( _
'      ByRef ndim As long, _
'      ByVal x_rptr As longPtr _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub D01JAF Lib "NLW32293E_nag.dll" ( _
    ByVal f As longPtr, _
    ByRef ndim As long, _
    ByRef radius As double, _
    ByRef epsa As double, _
    ByRef epsr As double, _
    ByRef method As long, _
    ByRef icoord As long, _
    ByRef result As double, _
    ByRef esterr As double, _
    ByRef nevals As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Function D01PAF_F( _
'      ByRef ndim As long, _
'      ByVal x_rptr As longPtr _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub D01PAF Lib "NLW32293E_nag.dll" ( _
    ByRef ndim As long, _
    ByRef vert As double, _
    ByRef ldvert As long, _
    ByRef sdvert As long, _
    ByVal f As longPtr, _
    ByRef minord As long, _
    ByRef maxord As long, _
    ByRef finvls As double, _
    ByRef esterr As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D01RAF Lib "NLW32293E_nag.dll" ( _
    ByRef irevcm As long, ByRef ni As long, ByRef a As double, _
    ByRef b As double, ByRef sid As long, ByRef needi As long, _
    ByRef x As double, ByRef lenx As long, ByRef nx As long, _
    ByRef fm As double, ByRef ldfm As long, ByRef dinest As double, _
    ByRef errest As double, ByRef iopts As long, ByRef opts As double, _
    ByRef icom As long, ByRef licom As long, ByRef com As double, _
    ByRef lcom As long, ByRef ifail As long _
   )


   Declare Ptrsafe Sub D01RCF Lib "NLW32293E_nag.dll" ( _
    ByRef ni As long, _
    ByRef lenxrq As long, _
    ByRef ldfmrq As long, _
    ByRef sdfmrq As long, _
    ByRef licmin As long, _
    ByRef licmax As long, _
    ByRef lcmin As long, _
    ByRef lcmax As long, _
    ByRef iopts As long, _
    ByRef opts As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D01RGF_F( _
'      ByVal x_rptr As longPtr, _
'      ByRef nx As long, _
'      ByVal fv_rptr As longPtr, _
'      ByRef iflag As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D01RGF Lib "NLW32293E_nag.dll" ( _
    ByRef a As double, _
    ByRef b As double, _
    ByVal f As longPtr, _
    ByRef epsabs As double, _
    ByRef epsrel As double, _
    ByRef dinest As double, _
    ByRef errest As double, _
    ByRef nevals As long, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D01RJF_F( _
'      ByVal x_rptr As longPtr, _
'      ByRef nx As long, _
'      ByVal fv_rptr As longPtr, _
'      ByRef iflag As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D01RJF Lib "NLW32293E_nag.dll" ( _
    ByVal f As longPtr, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef epsabs As double, _
    ByRef epsrel As double, _
    ByRef maxsub As long, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef rinfo As double, _
    ByRef iinfo As long, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef cpuser As longPtr, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D01RKF_F( _
'      ByVal x_rptr As longPtr, _
'      ByRef nx As long, _
'      ByVal fv_rptr As longPtr, _
'      ByRef iflag As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D01RKF Lib "NLW32293E_nag.dll" ( _
    ByVal f As longPtr, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef key As long, _
    ByRef epsabs As double, _
    ByRef epsrel As double, _
    ByRef maxsub As long, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef rinfo As double, _
    ByRef iinfo As long, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef cpuser As longPtr, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D01RLF_F( _
'      ByVal x_rptr As longPtr, _
'      ByRef nx As long, _
'      ByVal fv_rptr As longPtr, _
'      ByRef iflag As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D01RLF Lib "NLW32293E_nag.dll" ( _
    ByVal f As longPtr, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef npts As long, _
    ByRef points As double, _
    ByRef epsabs As double, _
    ByRef epsrel As double, _
    ByRef maxsub As long, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef rinfo As double, _
    ByRef iinfo As long, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef cpuser As longPtr, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D01RMF_F( _
'      ByVal x_rptr As longPtr, _
'      ByRef nx As long, _
'      ByVal fv_rptr As longPtr, _
'      ByRef iflag As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D01RMF Lib "NLW32293E_nag.dll" ( _
    ByVal f As longPtr, _
    ByRef bound As double, _
    ByRef inf As long, _
    ByRef epsabs As double, _
    ByRef epsrel As double, _
    ByRef maxsub As long, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef rinfo As double, _
    ByRef iinfo As long, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef cpuser As longPtr, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D01TBF Lib "NLW32293E_nag.dll" ( _
    ByRef key As long, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef n As long, _
    ByRef weight As double, _
    ByRef abscis As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D01TCF Lib "NLW32293E_nag.dll" ( _
    ByRef itype As long, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef c As double, _
    ByRef d As double, _
    ByRef n As long, _
    ByRef weight As double, _
    ByRef abscis As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D01TDF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef c As double, _
    ByRef muzero As double, _
    ByRef weight As double, _
    ByRef abscis As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D01TEF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef mu As double, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef c As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D01UAF_F( _
'      ByVal x_rptr As longPtr, _
'      ByRef nx As long, _
'      ByVal fv_rptr As longPtr, _
'      ByRef iflag As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D01UAF Lib "NLW32293E_nag.dll" ( _
    ByRef key As long, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef n As long, _
    ByVal f As longPtr, _
    ByRef dinest As double, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D01UBF_F( _
'      ByVal x_rptr As longPtr, _
'      ByVal fv_rptr As longPtr, _
'      ByRef n As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef istop As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D01UBF Lib "NLW32293E_nag.dll" ( _
    ByVal f As longPtr, _
    ByRef n As long, _
    ByRef ans As double, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D01ZKF Lib "NLW32293E_nag.dll" ( _
    ByVal optstr As string, ByVal optstrlength As long, _
    ByRef iopts As long, _
    ByRef liopts As long, _
    ByRef opts As double, _
    ByRef lopts As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D01ZLF Lib "NLW32293E_nag.dll" ( _
    ByVal optstr As string, ByVal optstrlength As long, _
    ByRef ivalue As long, _
    ByRef rvalue As double, _
    ByVal cvalue As string, ByVal cvaluelength As long, _
    ByRef optype As long, _
    ByRef iopts As long, _
    ByRef opts As double, _
    ByRef ifail As long _
   )


' chapter d02

' skeleton code for callback function
'  Sub D02AGF_AUX( _
'      ByVal f_rptr As longPtr, _
'      ByVal y_rptr As longPtr, _
'      ByRef x As double, _
'      ByVal param_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02AGF_BCAUX( _
'      ByVal g0_rptr As longPtr, _
'      ByVal g1_rptr As longPtr, _
'      ByVal param_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02AGF_RAAUX( _
'      ByRef x0 As double, _
'      ByRef x1 As double, _
'      ByRef r As double, _
'      ByVal param_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02AGF_PRSOL( _
'      ByVal param_rptr As longPtr, _
'      ByRef res As double, _
'      ByRef n1 As long, _
'      ByVal err_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D02AGF Lib "NLW32293E_nag.dll" ( _
    ByRef h As double, _
    ByRef e As double, _
    ByRef parerr As double, _
    ByRef param As double, _
    ByRef c As double, _
    ByRef n As long, _
    ByRef n1 As long, _
    ByRef m1 As long, _
    ByVal aux As longPtr, _
    ByVal bcaux As longPtr, _
    ByVal raaux As longPtr, _
    ByVal prsol As longPtr, _
    ByRef mat As double, _
    ByRef copy As double, _
    ByRef wspace As double, _
    ByRef wspac1 As double, _
    ByRef wspac2 As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D02BGF_FCN( _
'      ByRef x As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal f_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D02BGF Lib "NLW32293E_nag.dll" ( _
    ByRef x As double, _
    ByRef xend As double, _
    ByRef n As long, _
    ByRef y As double, _
    ByRef tol As double, _
    ByRef hmax As double, _
    ByRef m As long, _
    ByRef val As double, _
    ByVal fcn As longPtr, _
    ByRef w As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D02BHF_FCN( _
'      ByRef x As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal f_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Function D02BHF_G( _
'      ByRef x As double, _
'      ByVal y_rptr As longPtr _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub D02BHF Lib "NLW32293E_nag.dll" ( _
    ByRef x As double, _
    ByRef xend As double, _
    ByRef n As long, _
    ByRef y As double, _
    ByRef tol As double, _
    ByRef irelab As long, _
    ByRef hmax As double, _
    ByVal fcn As longPtr, _
    ByVal g As longPtr, _
    ByRef w As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D02BJF_FCN( _
'      ByRef x As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal f_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02BJF_OUTPUT( _
'      ByRef xsol As double, _
'      ByVal y_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D02BJX Lib "NLW32293E_nag.dll" ( _
    ByRef xsol As double, _
    ByVal y_rptr As longPtr _
  )

' skeleton code for callback function
'  Function D02BJF_G( _
'      ByRef x As double, _
'      ByVal y_rptr As longPtr _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Function D02BJW Lib "NLW32293E_nag.dll" ( _
    ByRef x As double, _
    ByVal y_rptr As longPtr _
  ) As double

   Declare Ptrsafe Sub D02BJF Lib "NLW32293E_nag.dll" ( _
    ByRef x As double, _
    ByRef xend As double, _
    ByRef n As long, _
    ByRef y As double, _
    ByVal fcn As longPtr, _
    ByRef tol As double, _
    ByVal relabs As string, ByVal relabslength As long, _
    ByVal output As longPtr, _
    ByVal g As longPtr, _
    ByRef w As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D02CJF_FCN( _
'      ByRef x As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal f_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02CJF_OUTPUT( _
'      ByRef xsol As double, _
'      ByVal y_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D02CJX Lib "NLW32293E_nag.dll" ( _
    ByRef xsol As double, _
    ByVal y_rptr As longPtr _
  )

' skeleton code for callback function
'  Function D02CJF_G( _
'      ByRef x As double, _
'      ByVal y_rptr As longPtr _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Function D02CJW Lib "NLW32293E_nag.dll" ( _
    ByRef x As double, _
    ByVal y_rptr As longPtr _
  ) As double

   Declare Ptrsafe Sub D02CJF Lib "NLW32293E_nag.dll" ( _
    ByRef x As double, _
    ByRef xend As double, _
    ByRef n As long, _
    ByRef y As double, _
    ByVal fcn As longPtr, _
    ByRef tol As double, _
    ByVal relabs As string, ByVal relabslength As long, _
    ByVal output As longPtr, _
    ByVal g As longPtr, _
    ByRef w As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D02EJF_FCN( _
'      ByRef x As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal f_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02EJF_PEDERV( _
'      ByRef x As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal pw_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D02EJY Lib "NLW32293E_nag.dll" ( _
    ByRef x As double, _
    ByVal y_rptr As longPtr, _
    ByVal pw_rptr As longPtr _
  )

' skeleton code for callback function
'  Sub D02EJF_OUTPUT( _
'      ByRef xsol As double, _
'      ByVal y_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D02EJX Lib "NLW32293E_nag.dll" ( _
    ByRef xsol As double, _
    ByVal y_rptr As longPtr _
  )

' skeleton code for callback function
'  Function D02EJF_G( _
'      ByRef x As double, _
'      ByVal y_rptr As longPtr _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Function D02EJW Lib "NLW32293E_nag.dll" ( _
    ByRef x As double, _
    ByVal y_rptr As longPtr _
  ) As double

   Declare Ptrsafe Sub D02EJF Lib "NLW32293E_nag.dll" ( _
    ByRef x As double, _
    ByRef xend As double, _
    ByRef n As long, _
    ByRef y As double, _
    ByVal fcn As longPtr, _
    ByVal pederv As longPtr, _
    ByRef tol As double, _
    ByVal relabs As string, ByVal relabslength As long, _
    ByVal output As longPtr, _
    ByVal g As longPtr, _
    ByRef w As double, _
    ByRef iw As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D02GAF_FCN( _
'      ByRef x As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal f_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D02GAF Lib "NLW32293E_nag.dll" ( _
    ByRef u As double, _
    ByRef v As double, _
    ByRef n As long, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef tol As double, _
    ByVal fcn As longPtr, _
    ByRef mnp As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef np As long, _
    ByRef w As double, _
    ByRef lw As long, _
    ByRef iw As long, _
    ByRef liw As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02GAW Lib "NLW32293E_nag.dll" ( _
    ByRef x As double, _
    ByRef eps As double, _
    ByRef y As double, _
    ByRef f As double, _
    ByRef n As long _
   )


   Declare Ptrsafe Sub D02GAX Lib "NLW32293E_nag.dll" ( _
    ByRef eps As double, _
    ByRef ya As double, _
    ByRef yb As double, _
    ByRef bcep As double, _
    ByRef n As long _
   )


   Declare Ptrsafe Sub D02GAY Lib "NLW32293E_nag.dll" ( _
    ByRef eps As double, _
    ByRef ya As double, _
    ByRef yb As double, _
    ByRef aj As double, _
    ByRef bj As double, _
    ByRef n As long _
   )


   Declare Ptrsafe Sub D02GAZ Lib "NLW32293E_nag.dll" ( _
    ByRef x As double, _
    ByRef eps As double, _
    ByRef y As double, _
    ByRef f As double, _
    ByRef n As long _
   )


' skeleton code for callback function
'  Sub D02GBF_FCNF( _
'      ByRef x As double, _
'      ByVal f_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02GBF_FCNG( _
'      ByRef x As double, _
'      ByVal g_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D02GBF Lib "NLW32293E_nag.dll" ( _
    ByRef a As double, _
    ByRef b As double, _
    ByRef n As long, _
    ByRef tol As double, _
    ByVal fcnf As longPtr, _
    ByVal fcng As longPtr, _
    ByRef c As double, _
    ByRef d As double, _
    ByRef gam As double, _
    ByRef mnp As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef np As long, _
    ByRef w As double, _
    ByRef lw As long, _
    ByRef iw As long, _
    ByRef liw As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D02HAF_FCN( _
'      ByRef x As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal f_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D02HAF Lib "NLW32293E_nag.dll" ( _
    ByRef u As double, _
    ByRef v As double, _
    ByRef n As long, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef tol As double, _
    ByVal fcn As longPtr, _
    ByRef soln As double, _
    ByRef m1 As long, _
    ByRef w As double, _
    ByRef sdw As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D02HBF_FCN( _
'      ByRef x As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByVal p_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02HBF_BC( _
'      ByVal g1_rptr As longPtr, _
'      ByVal g2_rptr As longPtr, _
'      ByVal p_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02HBF_RANGE( _
'      ByRef a As double, _
'      ByRef b As double, _
'      ByVal p_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D02HBF Lib "NLW32293E_nag.dll" ( _
    ByRef p As double, _
    ByRef n1 As long, _
    ByRef pe As double, _
    ByRef e As double, _
    ByRef n As long, _
    ByRef soln As double, _
    ByRef m1 As long, _
    ByVal fcn As longPtr, _
    ByVal bc As longPtr, _
    ByVal range As longPtr, _
    ByRef w As double, _
    ByRef sdw As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02HBW Lib "NLW32293E_nag.dll" ( _
    ByRef z As double, _
    ByRef y As double, _
    ByRef n As long _
   )


   Declare Ptrsafe Sub D02HBZ Lib "NLW32293E_nag.dll" ( _
    ByRef e As double, _
    ByRef q As long, _
    ByRef p As double, _
    ByRef m As long _
   )


' skeleton code for callback function
'  Function D02JAF_CF( _
'      ByRef j As long, _
'      ByRef x As double _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Sub D02JAF_BC( _
'      ByRef i As long, _
'      ByRef j As long, _
'      ByRef rhs As double _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D02JAF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByVal cf As longPtr, _
    ByVal bc As longPtr, _
    ByRef x0 As double, _
    ByRef x1 As double, _
    ByRef k1 As long, _
    ByRef kp As long, _
    ByRef c As double, _
    ByRef w As double, _
    ByRef lw As long, _
    ByRef iw As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Function D02JBF_CF( _
'      ByRef i As long, _
'      ByRef j As long, _
'      ByRef x As double _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Sub D02JBF_BC( _
'      ByRef i As long, _
'      ByRef j As long, _
'      ByRef rhs As double _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D02JBF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByVal cf As longPtr, _
    ByVal bc As longPtr, _
    ByRef x0 As double, _
    ByRef x1 As double, _
    ByRef k1 As long, _
    ByRef kp As long, _
    ByRef c As double, _
    ByRef ldc As long, _
    ByRef w As double, _
    ByRef lw As long, _
    ByRef iw As long, _
    ByRef liw As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D02KAF_COEFFN( _
'      ByRef p As double, _
'      ByRef q As double, _
'      ByRef dqdl As double, _
'      ByRef x As double, _
'      ByRef elam As double, _
'      ByRef jint As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02KAF_MONIT( _
'      ByRef nit As long, _
'      ByRef iflag As long, _
'      ByRef elam As double, _
'      ByVal finfo_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D02KAY Lib "NLW32293E_nag.dll" ( _
    ByRef nit As long, _
    ByRef iflag As long, _
    ByRef elam As double, _
    ByVal finfo_rptr As longPtr _
  )

   Declare Ptrsafe Sub D02KAF Lib "NLW32293E_nag.dll" ( _
    ByRef xl As double, _
    ByRef xr As double, _
    ByVal coeffn As longPtr, _
    ByRef bcond As double, _
    ByRef k As long, _
    ByRef tol As double, _
    ByRef elam As double, _
    ByRef delam As double, _
    ByVal monit As longPtr, _
    ByRef ifail As long _
   )




' skeleton code for callback function
'  Sub D02KDF_COEFFN( _
'      ByRef p As double, _
'      ByRef q As double, _
'      ByRef dqdl As double, _
'      ByRef x As double, _
'      ByRef elam As double, _
'      ByRef jint As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02KDF_BDYVAL( _
'      ByRef xl As double, _
'      ByRef xr As double, _
'      ByRef elam As double, _
'      ByVal yl_rptr As longPtr, _
'      ByVal yr_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02KDF_MONIT( _
'      ByRef nit As long, _
'      ByRef iflag As long, _
'      ByRef elam As double, _
'      ByVal finfo_rptr As longPtr _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub D02KDF Lib "NLW32293E_nag.dll" ( _
    ByRef xpoint As double, _
    ByRef m As long, _
    ByVal coeffn As longPtr, _
    ByVal bdyval As longPtr, _
    ByRef k As long, _
    ByRef tol As double, _
    ByRef elam As double, _
    ByRef delam As double, _
    ByRef hmax As double, _
    ByRef maxit As long, _
    ByRef maxfun As long, _
    ByVal monit As longPtr, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D02KEF_COEFFN( _
'      ByRef p As double, _
'      ByRef q As double, _
'      ByRef dqdl As double, _
'      ByRef x As double, _
'      ByRef elam As double, _
'      ByRef jint As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02KEF_BDYVAL( _
'      ByRef xl As double, _
'      ByRef xr As double, _
'      ByRef elam As double, _
'      ByVal yl_rptr As longPtr, _
'      ByVal yr_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02KEF_MONIT( _
'      ByRef nit As long, _
'      ByRef iflag As long, _
'      ByRef elam As double, _
'      ByVal finfo_rptr As longPtr _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub D02KEF_REPORT( _
'      ByRef x As double, _
'      ByVal v_rptr As longPtr, _
'      ByRef jint As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D02KEF Lib "NLW32293E_nag.dll" ( _
    ByRef xpoint As double, _
    ByRef m As long, _
    ByRef match As long, _
    ByVal coeffn As longPtr, _
    ByVal bdyval As longPtr, _
    ByRef k As long, _
    ByRef tol As double, _
    ByRef elam As double, _
    ByRef delam As double, _
    ByRef hmax As double, _
    ByRef maxit As long, _
    ByRef maxfun As long, _
    ByVal monit As longPtr, _
    ByVal report As longPtr, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D02LAF_FCN( _
'      ByRef neq As long, _
'      ByRef t As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal f_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D02LAF Lib "NLW32293E_nag.dll" ( _
    ByVal fcn As longPtr, _
    ByRef neq As long, _
    ByRef t As double, _
    ByRef tend As double, _
    ByRef y As double, _
    ByRef yp As double, _
    ByRef ydp As double, _
    ByRef rwork As double, _
    ByRef lrwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02LXF Lib "NLW32293E_nag.dll" ( _
    ByRef neq As long, _
    ByRef h As double, _
    ByRef tol As double, _
    ByRef thres As double, _
    ByRef thresp As double, _
    ByRef maxstp As long, _
    ByRef start As long, _
    ByRef onestp As long, _
    ByRef high As long, _
    ByRef rwork As double, _
    ByRef lrwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02LYF Lib "NLW32293E_nag.dll" ( _
    ByRef neq As long, _
    ByRef hnext As double, _
    ByRef hused As double, _
    ByRef hstart As double, _
    ByRef nsucc As long, _
    ByRef nfail As long, _
    ByRef natt As long, _
    ByRef thres As double, _
    ByRef thresp As double, _
    ByRef rwork As double, _
    ByRef lrwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02LZF Lib "NLW32293E_nag.dll" ( _
    ByRef neq As long, _
    ByRef t As double, _
    ByRef y As double, _
    ByRef yp As double, _
    ByRef nwant As long, _
    ByRef twant As double, _
    ByRef ywant As double, _
    ByRef ypwant As double, _
    ByRef rwork As double, _
    ByRef lrwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02MCF Lib "NLW32293E_nag.dll" ( _
    ByRef icom As long _
   )


   Declare Ptrsafe Sub D02MVF Lib "NLW32293E_nag.dll" ( _
    ByRef neqmax As long, _
    ByRef sdysav As long, _
    ByRef maxord As long, _
    ByRef con As double, _
    ByRef tcrit As double, _
    ByRef hmin As double, _
    ByRef hmax As double, _
    ByRef h0 As double, _
    ByRef maxstp As long, _
    ByRef mxhnil As long, _
    ByVal norm As string, ByVal normlength As long, _
    ByRef rwork As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02MWF Lib "NLW32293E_nag.dll" ( _
    ByRef neq As long, _
    ByRef maxord As long, _
    ByVal jceval As string, ByVal jcevallength As long, _
    ByRef hmax As double, _
    ByRef h0 As double, _
    ByRef itol As long, _
    ByRef icom As long, _
    ByRef licom As long, _
    ByRef com As double, _
    ByRef lcom As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02MZF Lib "NLW32293E_nag.dll" ( _
    ByRef tsol As double, _
    ByRef sol As double, _
    ByRef m As long, _
    ByRef ldysav As long, _
    ByRef neq As long, _
    ByRef ysav As double, _
    ByRef sdysav As long, _
    ByRef rwork As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D02NBF_FCN( _
'      ByRef neq As long, _
'      ByRef t As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02NBF_JAC( _
'      ByRef neq As long, _
'      ByRef t As double, _
'      ByVal y_rptr As longPtr, _
'      ByRef h As double, _
'      ByRef d As double, _
'      ByVal p_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D02NBZ Lib "NLW32293E_nag.dll" ( _
    ByRef neq As long, _
    ByRef t As double, _
    ByVal y_rptr As longPtr, _
    ByRef h As double, _
    ByRef d As double, _
    ByVal p_rptr As longPtr _
  )

' skeleton code for callback function
'  Sub D02NBF_MONITR( _
'      ByRef neq As long, _
'      ByRef ldysav As long, _
'      ByRef t As double, _
'      ByRef hlast As double, _
'      ByRef hnext As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal ydot_rptr As longPtr, _
'      ByVal ysav_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByVal acor_rptr As longPtr, _
'      ByRef imon As long, _
'      ByRef inln As long, _
'      ByRef hmin As double, _
'      ByRef hmax As double, _
'      ByRef nqu As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D02NBY Lib "NLW32293E_nag.dll" ( _
    ByRef neq As long, _
    ByRef ldysav As long, _
    ByRef t As double, _
    ByRef hlast As double, _
    ByRef hnext As double, _
    ByVal y_rptr As longPtr, _
    ByVal ydot_rptr As longPtr, _
    ByVal ysav_rptr As longPtr, _
    ByVal r_rptr As longPtr, _
    ByVal acor_rptr As longPtr, _
    ByRef imon As long, _
    ByRef inln As long, _
    ByRef hmin As double, _
    ByRef hmax As double, _
    ByRef nqu As long _
  )

   Declare Ptrsafe Sub D02NBF Lib "NLW32293E_nag.dll" ( _
    ByRef neq As long, ByRef ldysav As long, ByRef t As double, _
    ByRef tout As double, ByRef y As double, ByRef ydot As double, _
    ByRef rwork As double, ByRef rtol As double, ByRef atol As double, _
    ByRef itol As long, ByRef inform As long, ByVal fcn As longPtr, _
    ByRef ysav As double, ByRef sdysav As long, ByVal jac As longPtr, _
    ByRef wkjac As double, ByRef nwkjac As long, ByVal monitr As longPtr, _
    ByRef itask As long, ByRef itrace As long, ByRef ifail As long _
   )






' skeleton code for callback function
'  Sub D02NCF_FCN( _
'      ByRef neq As long, _
'      ByRef t As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02NCF_JAC( _
'      ByRef neq As long, _
'      ByRef t As double, _
'      ByVal y_rptr As longPtr, _
'      ByRef h As double, _
'      ByRef d As double, _
'      ByRef ml As long, _
'      ByRef mu As long, _
'      ByVal p_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D02NCZ Lib "NLW32293E_nag.dll" ( _
    ByRef neq As long, _
    ByRef t As double, _
    ByVal y_rptr As longPtr, _
    ByRef h As double, _
    ByRef d As double, _
    ByRef ml As long, _
    ByRef mu As long, _
    ByVal p_rptr As longPtr _
  )

' skeleton code for callback function
'  Sub D02NCF_MONITR( _
'      ByRef neq As long, _
'      ByRef ldysav As long, _
'      ByRef t As double, _
'      ByRef hlast As double, _
'      ByRef hnext As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal ydot_rptr As longPtr, _
'      ByVal ysav_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByVal acor_rptr As longPtr, _
'      ByRef imon As long, _
'      ByRef inln As long, _
'      ByRef hmin As double, _
'      ByRef hmax As double, _
'      ByRef nqu As long _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub D02NCF Lib "NLW32293E_nag.dll" ( _
    ByRef neq As long, ByRef ldysav As long, ByRef t As double, _
    ByRef tout As double, ByRef y As double, ByRef ydot As double, _
    ByRef rwork As double, ByRef rtol As double, ByRef atol As double, _
    ByRef itol As long, ByRef inform As long, ByVal fcn As longPtr, _
    ByRef ysav As double, ByRef sdysav As long, ByVal jac As longPtr, _
    ByRef wkjac As double, ByRef nwkjac As long, ByRef jacpvt As long, _
    ByRef njcpvt As long, ByVal monitr As longPtr, _
    ByRef itask As long, _
    ByRef itrace As long, ByRef ifail As long _
   )




' skeleton code for callback function
'  Sub D02NDF_FCN( _
'      ByRef neq As long, _
'      ByRef t As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02NDF_JAC( _
'      ByRef neq As long, _
'      ByRef t As double, _
'      ByVal y_rptr As longPtr, _
'      ByRef h As double, _
'      ByRef d As double, _
'      ByRef j As long, _
'      ByVal pdj_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D02NDZ Lib "NLW32293E_nag.dll" ( _
    ByRef neq As long, _
    ByRef t As double, _
    ByVal y_rptr As longPtr, _
    ByRef h As double, _
    ByRef d As double, _
    ByRef j As long, _
    ByVal pdj_rptr As longPtr _
  )

' skeleton code for callback function
'  Sub D02NDF_MONITR( _
'      ByRef neq As long, _
'      ByRef ldysav As long, _
'      ByRef t As double, _
'      ByRef hlast As double, _
'      ByRef hnext As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal ydot_rptr As longPtr, _
'      ByVal ysav_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByVal acor_rptr As longPtr, _
'      ByRef imon As long, _
'      ByRef inln As long, _
'      ByRef hmin As double, _
'      ByRef hmax As double, _
'      ByRef nqu As long _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub D02NDF Lib "NLW32293E_nag.dll" ( _
    ByRef neq As long, ByRef ldysav As long, ByRef t As double, _
    ByRef tout As double, ByRef y As double, ByRef ydot As double, _
    ByRef rwork As double, ByRef rtol As double, ByRef atol As double, _
    ByRef itol As long, ByRef inform As long, ByVal fcn As longPtr, _
    ByRef ysav As double, ByRef sdysav As long, ByVal jac As longPtr, _
    ByRef wkjac As double, ByRef nwkjac As long, ByRef jacpvt As long, _
    ByRef njcpvt As long, ByVal monitr As longPtr, _
    ByRef itask As long, _
    ByRef itrace As long, ByRef ifail As long _
   )




' skeleton code for callback function
'  Sub D02NEF_RES( _
'      ByRef neq As long, _
'      ByRef t As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal ydot_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByRef ires As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02NEF_JAC( _
'      ByRef neq As long, _
'      ByRef t As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal ydot_rptr As longPtr, _
'      ByVal pd_rptr As longPtr, _
'      ByRef cj As double, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D02NEZ Lib "NLW32293E_nag.dll" ( _
    ByRef neq As long, _
    ByRef t As double, _
    ByVal y_rptr As longPtr, _
    ByVal ydot_rptr As longPtr, _
    ByVal pd_rptr As longPtr, _
    ByRef cj As double, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr _
  )

   Declare Ptrsafe Sub D02NEF Lib "NLW32293E_nag.dll" ( _
    ByRef neq As long, _
    ByRef t As double, _
    ByRef tout As double, _
    ByRef y As double, _
    ByRef ydot As double, _
    ByRef rtol As double, _
    ByRef atol As double, _
    ByRef itask As long, _
    ByVal res As longPtr, _
    ByVal jac As longPtr, _
    ByRef icom As long, _
    ByRef com As double, _
    ByRef lcom As long, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef ifail As long _
   )




' skeleton code for callback function
'  Sub D02NGF_RESID( _
'      ByRef neq As long, _
'      ByRef t As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal ydot_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02NGF_JAC( _
'      ByRef neq As long, _
'      ByRef t As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal ydot_rptr As longPtr, _
'      ByRef h As double, _
'      ByRef d As double, _
'      ByVal p_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D02NGZ Lib "NLW32293E_nag.dll" ( _
    ByRef neq As long, _
    ByRef t As double, _
    ByVal y_rptr As longPtr, _
    ByVal ydot_rptr As longPtr, _
    ByRef h As double, _
    ByRef d As double, _
    ByVal p_rptr As longPtr _
  )

' skeleton code for callback function
'  Sub D02NGF_MONITR( _
'      ByRef neq As long, _
'      ByRef ldysav As long, _
'      ByRef t As double, _
'      ByRef hlast As double, _
'      ByRef hnext As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal ydot_rptr As longPtr, _
'      ByVal ysav_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByVal acor_rptr As longPtr, _
'      ByRef imon As long, _
'      ByRef inln As long, _
'      ByRef hmin As double, _
'      ByRef hmax As double, _
'      ByRef nqu As long _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub D02NGF Lib "NLW32293E_nag.dll" ( _
    ByRef neq As long, ByRef ldysav As long, ByRef t As double, _
    ByRef tout As double, ByRef y As double, ByRef ydot As double, _
    ByRef rwork As double, ByRef rtol As double, ByRef atol As double, _
    ByRef itol As long, ByRef inform As long, ByVal resid As longPtr, _
    ByRef ysav As double, ByRef sdysav As long, ByVal jac As longPtr, _
    ByRef wkjac As double, ByRef nwkjac As long, ByVal monitr As longPtr, _
    ByRef lderiv As long, ByRef itask As long, ByRef itrace As long, _
    ByRef ifail As long _
   )




' skeleton code for callback function
'  Sub D02NHF_RESID( _
'      ByRef neq As long, _
'      ByRef t As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal ydot_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02NHF_JAC( _
'      ByRef neq As long, _
'      ByRef t As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal ydot_rptr As longPtr, _
'      ByRef h As double, _
'      ByRef d As double, _
'      ByRef ml As long, _
'      ByRef mu As long, _
'      ByVal p_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D02NHZ Lib "NLW32293E_nag.dll" ( _
    ByRef neq As long, _
    ByRef t As double, _
    ByVal y_rptr As longPtr, _
    ByVal ydot_rptr As longPtr, _
    ByRef h As double, _
    ByRef d As double, _
    ByRef ml As long, _
    ByRef mu As long, _
    ByVal p_rptr As longPtr _
  )

' skeleton code for callback function
'  Sub D02NHF_MONITR( _
'      ByRef neq As long, _
'      ByRef ldysav As long, _
'      ByRef t As double, _
'      ByRef hlast As double, _
'      ByRef hnext As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal ydot_rptr As longPtr, _
'      ByVal ysav_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByVal acor_rptr As longPtr, _
'      ByRef imon As long, _
'      ByRef inln As long, _
'      ByRef hmin As double, _
'      ByRef hmax As double, _
'      ByRef nqu As long _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub D02NHF Lib "NLW32293E_nag.dll" ( _
    ByRef neq As long, ByRef ldysav As long, ByRef t As double, _
    ByRef tout As double, ByRef y As double, ByRef ydot As double, _
    ByRef rwork As double, ByRef rtol As double, ByRef atol As double, _
    ByRef itol As long, ByRef inform As long, ByVal resid As longPtr, _
    ByRef ysav As double, ByRef sdysav As long, ByVal jac As longPtr, _
    ByRef wkjac As double, ByRef nwkjac As long, ByRef jacpvt As long, _
    ByRef njcpvt As long, ByVal monitr As longPtr, ByRef lderiv As long, _
    ByRef itask As long, ByRef itrace As long, ByRef ifail As long _
   )




' skeleton code for callback function
'  Sub D02NJF_RESID( _
'      ByRef neq As long, _
'      ByRef t As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal ydot_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02NJF_JAC( _
'      ByRef neq As long, _
'      ByRef t As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal ydot_rptr As longPtr, _
'      ByRef h As double, _
'      ByRef d As double, _
'      ByRef j As long, _
'      ByVal pdj_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D02NJZ Lib "NLW32293E_nag.dll" ( _
    ByRef neq As long, _
    ByRef t As double, _
    ByVal y_rptr As longPtr, _
    ByVal ydot_rptr As longPtr, _
    ByRef h As double, _
    ByRef d As double, _
    ByRef j As long, _
    ByVal pdj_rptr As longPtr _
  )

' skeleton code for callback function
'  Sub D02NJF_MONITR( _
'      ByRef neq As long, _
'      ByRef ldysav As long, _
'      ByRef t As double, _
'      ByRef hlast As double, _
'      ByRef hnext As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal ydot_rptr As longPtr, _
'      ByVal ysav_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByVal acor_rptr As longPtr, _
'      ByRef imon As long, _
'      ByRef inln As long, _
'      ByRef hmin As double, _
'      ByRef hmax As double, _
'      ByRef nqu As long _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub D02NJF Lib "NLW32293E_nag.dll" ( _
    ByRef neq As long, ByRef ldysav As long, ByRef t As double, _
    ByRef tout As double, ByRef y As double, ByRef ydot As double, _
    ByRef rwork As double, ByRef rtol As double, ByRef atol As double, _
    ByRef itol As long, ByRef inform As long, ByVal resid As longPtr, _
    ByRef ysav As double, ByRef sdysav As long, ByVal jac As longPtr, _
    ByRef wkjac As double, ByRef nwkjac As long, ByRef jacpvt As long, _
    ByRef njcpvt As long, ByVal monitr As longPtr, ByRef lderiv As long, _
    ByRef itask As long, ByRef itrace As long, ByRef ifail As long _
   )




   Declare Ptrsafe Sub D02NMF Lib "NLW32293E_nag.dll" ( _
    ByRef neq As long, ByRef ldysav As long, ByRef t As double, _
    ByRef tout As double, ByRef y As double, ByRef ydot As double, _
    ByRef rwork As double, ByRef rtol As double, ByRef atol As double, _
    ByRef itol As long, ByRef inform As long, ByRef ysav As double, _
    ByRef sdysav As long, ByRef wkjac As double, ByRef nwkjac As long, _
    ByRef jacpvt As long, ByRef njcpvt As long, ByRef imon As long, _
    ByRef inln As long, ByRef ires As long, ByRef irevcm As long, _
    ByRef itask As long, ByRef itrace As long, ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02NNF Lib "NLW32293E_nag.dll" ( _
    ByRef neq As long, ByRef ldysav As long, ByRef t As double, _
    ByRef tout As double, ByRef y As double, ByRef ydot As double, _
    ByRef rwork As double, ByRef rtol As double, ByRef atol As double, _
    ByRef itol As long, ByRef inform As long, ByRef ysav As double, _
    ByRef sdysav As long, ByRef wkjac As double, ByRef nwkjac As long, _
    ByRef jacpvt As long, ByRef njcpvt As long, ByRef imon As long, _
    ByRef inln As long, ByRef ires As long, ByRef irevcm As long, _
    ByRef lderiv As long, ByRef itask As long, ByRef itrace As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02NPF Lib "NLW32293E_nag.dll" ( _
    ByRef neq As long, _
    ByRef ml As long, _
    ByRef mu As long, _
    ByRef icom As long, _
    ByRef licom As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02NRF Lib "NLW32293E_nag.dll" ( _
    ByRef j As long, _
    ByRef iplace As long, _
    ByRef inform As long _
   )


   Declare Ptrsafe Sub D02NSF Lib "NLW32293E_nag.dll" ( _
    ByRef neq As long, _
    ByRef neqmax As long, _
    ByVal jceval As string, ByVal jcevallength As long, _
    ByRef nwkjac As long, _
    ByRef rwork As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02NTF Lib "NLW32293E_nag.dll" ( _
    ByRef neq As long, _
    ByRef neqmax As long, _
    ByVal jceval As string, ByVal jcevallength As long, _
    ByRef ml As long, _
    ByRef mu As long, _
    ByRef nwkjac As long, _
    ByRef njcpvt As long, _
    ByRef rwork As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02NUF Lib "NLW32293E_nag.dll" ( _
    ByRef neq As long, _
    ByRef neqmax As long, _
    ByVal jceval As string, ByVal jcevallength As long, _
    ByRef nwkjac As long, _
    ByRef ia As long, _
    ByRef nia As long, _
    ByRef ja As long, _
    ByRef nja As long, _
    ByRef jacpvt As long, _
    ByRef njcpvt As long, _
    ByRef sens As double, _
    ByRef u As double, _
    ByRef eta As double, _
    ByRef lblock As long, _
    ByRef isplit As long, _
    ByRef rwork As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02NVF Lib "NLW32293E_nag.dll" ( _
    ByRef neqmax As long, _
    ByRef sdysav As long, _
    ByRef maxord As long, _
    ByVal method As string, ByVal methodlength As long, _
    ByRef petzld As long, _
    ByRef con As double, _
    ByRef tcrit As double, _
    ByRef hmin As double, _
    ByRef hmax As double, _
    ByRef h0 As double, _
    ByRef maxstp As long, _
    ByRef mxhnil As long, _
    ByVal norm As string, ByVal normlength As long, _
    ByRef rwork As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02NWF Lib "NLW32293E_nag.dll" ( _
    ByRef neqmax As long, _
    ByRef sdysav As long, _
    ByRef maxord As long, _
    ByRef con As double, _
    ByRef tcrit As double, _
    ByRef hmin As double, _
    ByRef hmax As double, _
    ByRef h0 As double, _
    ByRef maxstp As long, _
    ByRef mxhnil As long, _
    ByVal norm As string, ByVal normlength As long, _
    ByRef rwork As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02NXF Lib "NLW32293E_nag.dll" ( _
    ByRef icall As long, _
    ByRef liwreq As long, _
    ByRef liwusd As long, _
    ByRef lrwreq As long, _
    ByRef lrwusd As long, _
    ByRef nlu As long, _
    ByRef nnz As long, _
    ByRef ngp As long, _
    ByRef isplit As long, _
    ByRef igrow As long, _
    ByRef lblock As long, _
    ByRef nblock As long, _
    ByRef inform As long _
   )


   Declare Ptrsafe Sub D02NYF Lib "NLW32293E_nag.dll" ( _
    ByRef neq As long, _
    ByRef neqmax As long, _
    ByRef hu As double, _
    ByRef h As double, _
    ByRef tcur As double, _
    ByRef tolsf As double, _
    ByRef rwork As double, _
    ByRef nst As long, _
    ByRef nre As long, _
    ByRef nje As long, _
    ByRef nqu As long, _
    ByRef nq As long, _
    ByRef niter As long, _
    ByRef imxer As long, _
    ByRef algequ As long, _
    ByRef inform As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02NZF Lib "NLW32293E_nag.dll" ( _
    ByRef neqmax As long, _
    ByRef tcrit As double, _
    ByRef h As double, _
    ByRef hmin As double, _
    ByRef hmax As double, _
    ByRef maxstp As long, _
    ByRef mxhnil As long, _
    ByRef rwork As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D02PEF_F( _
'      ByRef t As double, _
'      ByRef n As long, _
'      ByVal y_rptr As longPtr, _
'      ByVal yp_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D02PEF Lib "NLW32293E_nag.dll" ( _
    ByVal f As longPtr, _
    ByRef n As long, _
    ByRef twant As double, _
    ByRef tgot As double, _
    ByRef ygot As double, _
    ByRef ypgot As double, _
    ByRef ymax As double, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D02PFF_F( _
'      ByRef t As double, _
'      ByRef n As long, _
'      ByVal y_rptr As longPtr, _
'      ByVal yp_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D02PFF Lib "NLW32293E_nag.dll" ( _
    ByVal f As longPtr, _
    ByRef n As long, _
    ByRef tnow As double, _
    ByRef ynow As double, _
    ByRef ypnow As double, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02PGF Lib "NLW32293E_nag.dll" ( _
    ByRef irevcm As long, _
    ByRef n As long, _
    ByRef t As double, _
    ByRef y As double, _
    ByRef yp As double, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02PHF Lib "NLW32293E_nag.dll" ( _
    ByRef irevcm As long, _
    ByRef n As long, _
    ByRef nwant As long, _
    ByRef t As double, _
    ByRef y As double, _
    ByRef yp As double, _
    ByRef wcomm As double, _
    ByRef lwcomm As long, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02PJF Lib "NLW32293E_nag.dll" ( _
    ByRef icheck As long, _
    ByRef n As long, _
    ByRef nwant As long, _
    ByRef t As double, _
    ByRef ideriv As long, _
    ByRef sol As double, _
    ByRef wcomm As double, _
    ByRef lwcomm As long, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02PQF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef tstart As double, _
    ByRef tend As double, _
    ByRef yinit As double, _
    ByRef tol As double, _
    ByRef thresh As double, _
    ByRef method As long, _
    ByRef hstart As double, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02PRF Lib "NLW32293E_nag.dll" ( _
    ByRef tendnu As double, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D02PSF_F( _
'      ByRef t As double, _
'      ByRef n As long, _
'      ByVal y_rptr As longPtr, _
'      ByVal yp_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D02PSF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef twant As double, _
    ByRef ideriv As long, _
    ByRef nwant As long, _
    ByRef ywant As double, _
    ByRef ypwant As double, _
    ByVal f As longPtr, _
    ByRef wcomm As double, _
    ByRef lwcomm As long, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02PTF Lib "NLW32293E_nag.dll" ( _
    ByRef fevals As long, _
    ByRef stepcost As long, _
    ByRef waste As double, _
    ByRef stepsok As long, _
    ByRef hnext As double, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02PUF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef rmserr As double, _
    ByRef errmax As double, _
    ByRef terrmx As double, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D02QFF_FCN( _
'      ByRef neqf As long, _
'      ByRef x As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal f_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Function D02QFF_G( _
'      ByRef neqf As long, _
'      ByRef x As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal yp_rptr As longPtr, _
'      ByRef k As long _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Function D02QFZ Lib "NLW32293E_nag.dll" ( _
    ByRef neqf As long, _
    ByRef x As double, _
    ByVal y_rptr As longPtr, _
    ByVal yp_rptr As longPtr, _
    ByRef k As long _
  ) As double

   Declare Ptrsafe Sub D02QFF Lib "NLW32293E_nag.dll" ( _
    ByVal fcn As longPtr, _
    ByRef neqf As long, _
    ByRef t As double, _
    ByRef y As double, _
    ByRef tout As double, _
    ByVal g As longPtr, _
    ByRef neqg As long, _
    ByRef root As long, _
    ByRef rwork As double, _
    ByRef lrwork As long, _
    ByRef iwork As long, _
    ByRef liwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02QGF Lib "NLW32293E_nag.dll" ( _
    ByRef neqf As long, _
    ByRef t As double, _
    ByRef y As double, _
    ByRef tout As double, _
    ByRef neqg As long, _
    ByRef root As long, _
    ByRef irevcm As long, _
    ByRef trvcm As double, _
    ByRef yrvcm As long, _
    ByRef yprvcm As long, _
    ByRef grvcm As double, _
    ByRef kgrvcm As long, _
    ByRef rwork As double, _
    ByRef lrwork As long, _
    ByRef iwork As long, _
    ByRef liwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02QWF Lib "NLW32293E_nag.dll" ( _
    ByVal statef As string, ByVal stateflength As long, ByRef neqf As long, ByRef vectol As long, _
    ByRef atol As double, ByRef latol As long, ByRef rtol As double, _
    ByRef lrtol As long, ByRef onestp As long, ByRef crit As long, _
    ByRef tcrit As double, ByRef hmax As double, ByRef maxstp As long, _
    ByRef neqg As long, ByRef alterg As long, ByRef sophst As long, _
    ByRef rwork As double, ByRef lrwork As long, ByRef iwork As long, _
    ByRef liwork As long, ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02QXF Lib "NLW32293E_nag.dll" ( _
    ByRef neqf As long, _
    ByRef yp As double, _
    ByRef tcurr As double, _
    ByRef hlast As double, _
    ByRef hnext As double, _
    ByRef odlast As long, _
    ByRef odnext As long, _
    ByRef nsucc As long, _
    ByRef nfail As long, _
    ByRef tolfac As double, _
    ByRef badcmp As long, _
    ByRef rwork As double, _
    ByRef lrwork As long, _
    ByRef iwork As long, _
    ByRef liwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02QYF Lib "NLW32293E_nag.dll" ( _
    ByRef neqg As long, _
    ByRef index As long, _
    ByRef itype As long, _
    ByRef events As long, _
    ByRef resids As double, _
    ByRef rwork As double, _
    ByRef lrwork As long, _
    ByRef iwork As long, _
    ByRef liwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02QZF Lib "NLW32293E_nag.dll" ( _
    ByRef neqf As long, _
    ByRef twant As double, _
    ByRef nwant As long, _
    ByRef ywant As double, _
    ByRef ypwant As double, _
    ByRef rwork As double, _
    ByRef lrwork As long, _
    ByRef iwork As long, _
    ByRef liwork As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D02RAF_FCN( _
'      ByRef x As double, _
'      ByRef eps As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByRef n As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02RAF_G( _
'      ByRef eps As double, _
'      ByVal ya_rptr As longPtr, _
'      ByVal yb_rptr As longPtr, _
'      ByVal bc_rptr As longPtr, _
'      ByRef n As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02RAF_JACOBF( _
'      ByRef x As double, _
'      ByRef eps As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByRef n As long _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub D02RAF_JACOBG( _
'      ByRef eps As double, _
'      ByVal ya_rptr As longPtr, _
'      ByVal yb_rptr As longPtr, _
'      ByVal aj_rptr As longPtr, _
'      ByVal bj_rptr As longPtr, _
'      ByRef n As long _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub D02RAF_JACEPS( _
'      ByRef x As double, _
'      ByRef eps As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByRef n As long _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub D02RAF_JACGEP( _
'      ByRef eps As double, _
'      ByVal ya_rptr As longPtr, _
'      ByVal yb_rptr As longPtr, _
'      ByVal bcep_rptr As longPtr, _
'      ByRef n As long _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub D02RAF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, ByRef mnp As long, ByRef np As long, _
    ByRef numbeg As long, ByRef nummix As long, ByRef tol As double, _
    ByRef init As long, ByRef x As double, ByRef y As double, _
    ByRef ldy As long, ByRef abt As double, ByVal fcn As longPtr, _
    ByVal g As longPtr, _
    ByRef ijac As long, ByVal jacobf As longPtr, _
    ByVal jacobg As longPtr, _
    ByRef deleps As double, ByVal jaceps As longPtr, _
    ByVal jacgep As longPtr, ByRef work As double, ByRef lwork As long, _
    ByRef iwork As long, ByRef liwork As long, ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D02SAF_RANGE( _
'      ByVal x_rptr As longPtr, _
'      ByRef npoint As long, _
'      ByVal p_rptr As longPtr, _
'      ByRef m As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02SAF_BC( _
'      ByVal g1_rptr As longPtr, _
'      ByVal g2_rptr As longPtr, _
'      ByVal p_rptr As longPtr, _
'      ByRef m As long, _
'      ByRef n As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02SAF_FCN( _
'      ByRef x As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByRef n As long, _
'      ByVal p_rptr As longPtr, _
'      ByRef m As long, _
'      ByRef i As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02SAF_EQN( _
'      ByVal e_rptr As longPtr, _
'      ByRef q As long, _
'      ByVal p_rptr As longPtr, _
'      ByRef m As long _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Function D02SAF_CONSTR( _
'      ByVal p_rptr As longPtr, _
'      ByRef m As long _
'    ) As long
'      ' your code here
'  End Function

   Declare Ptrsafe Function D02HBY Lib "NLW32293E_nag.dll" ( _
    ByVal p_rptr As longPtr, _
    ByRef m As long _
  ) As long

' skeleton code for callback function
'  Sub D02SAF_MONIT( _
'      ByRef istate As long, _
'      ByRef iflag As long, _
'      ByRef ifail1 As long, _
'      ByVal p_rptr As longPtr, _
'      ByRef m As long, _
'      ByVal f_rptr As longPtr, _
'      ByRef pnorm As double, _
'      ByRef pnorm1 As double, _
'      ByRef eps As double, _
'      ByVal d_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D02SAS Lib "NLW32293E_nag.dll" ( _
    ByRef istate As long, _
    ByRef iflag As long, _
    ByRef ifail1 As long, _
    ByVal p_rptr As longPtr, _
    ByRef m As long, _
    ByVal f_rptr As longPtr, _
    ByRef pnorm As double, _
    ByRef pnorm1 As double, _
    ByRef eps As double, _
    ByVal d_rptr As longPtr _
  )

   Declare Ptrsafe Sub D02HBX Lib "NLW32293E_nag.dll" ( _
    ByRef istate As long, _
    ByRef iflag As long, _
    ByRef ifail1 As long, _
    ByVal p_rptr As longPtr, _
    ByRef m As long, _
    ByVal f_rptr As longPtr, _
    ByRef pnorm As double, _
    ByRef pnorm1 As double, _
    ByRef eps As double, _
    ByVal d_rptr As longPtr _
  )

' skeleton code for callback function
'  Sub D02SAF_PRSOL( _
'      ByRef z As double, _
'      ByVal y_rptr As longPtr, _
'      ByRef n As long _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub D02SAF Lib "NLW32293E_nag.dll" ( _
    ByRef p As double, ByRef m As long, ByRef n As long, _
    ByRef n1 As long, ByRef pe As double, ByRef pf As double, _
    ByRef e As double, ByRef dp As double, ByRef npoint As long, _
    ByRef swp As double, ByRef ldswp As long, ByRef icount As long, _
    ByVal range As longPtr, _
    ByVal bc As longPtr, _
    ByVal fcn As longPtr, _
    ByVal eqn As longPtr, _
    ByVal constr As longPtr, _
    ByRef ymax As double, _
    ByVal monit As longPtr, _
    ByVal prsol As longPtr, ByRef w As double, _
    ByRef ldw As long, ByRef sdw As long, ByRef ifail As long _
   )




' skeleton code for callback function
'  Sub D02TGF_COEFF( _
'      ByRef x As double, _
'      ByRef i As long, _
'      ByVal a_rptr As longPtr, _
'      ByRef ia As long, _
'      ByRef ia1 As long, _
'      ByRef rhs As double _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02TGF_BDYC( _
'      ByRef x As double, _
'      ByRef i As long, _
'      ByRef j As long, _
'      ByVal a_rptr As longPtr, _
'      ByRef ia As long, _
'      ByRef ia1 As long, _
'      ByRef rhs As double _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D02TGF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef m As long, _
    ByRef l As long, _
    ByRef x0 As double, _
    ByRef x1 As double, _
    ByRef k1 As long, _
    ByRef kp As long, _
    ByRef c As double, _
    ByRef ldc As long, _
    ByVal coeff As longPtr, _
    ByVal bdyc As longPtr, _
    ByRef w As double, _
    ByRef lw As long, _
    ByRef iw As long, _
    ByRef liw As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D02TLF_FFUN( _
'      ByRef x As double, _
'      ByVal y_rptr As longPtr, _
'      ByRef neq As long, _
'      ByVal m_iptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02TLF_FJAC( _
'      ByRef x As double, _
'      ByVal y_rptr As longPtr, _
'      ByRef neq As long, _
'      ByVal m_iptr As longPtr, _
'      ByVal dfdy_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02TLF_GAFUN( _
'      ByVal ya_rptr As longPtr, _
'      ByRef neq As long, _
'      ByVal m_iptr As longPtr, _
'      ByRef nlbc As long, _
'      ByVal ga_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02TLF_GBFUN( _
'      ByVal yb_rptr As longPtr, _
'      ByRef neq As long, _
'      ByVal m_iptr As longPtr, _
'      ByRef nrbc As long, _
'      ByVal gb_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02TLF_GAJAC( _
'      ByVal ya_rptr As longPtr, _
'      ByRef neq As long, _
'      ByVal m_iptr As longPtr, _
'      ByRef nlbc As long, _
'      ByVal dgady_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02TLF_GBJAC( _
'      ByVal yb_rptr As longPtr, _
'      ByRef neq As long, _
'      ByVal m_iptr As longPtr, _
'      ByRef nrbc As long, _
'      ByVal dgbdy_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D02TLF_GUESS( _
'      ByRef x As double, _
'      ByRef neq As long, _
'      ByVal m_iptr As longPtr, _
'      ByVal y_rptr As longPtr, _
'      ByVal dym_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D02TLF Lib "NLW32293E_nag.dll" ( _
    ByVal ffun As longPtr, _
    ByVal fjac As longPtr, _
    ByVal gafun As longPtr, _
    ByVal gbfun As longPtr, _
    ByVal gajac As longPtr, _
    ByVal gbjac As longPtr, _
    ByVal guess As longPtr, _
    ByRef rcomm As double, _
    ByRef icomm As long, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02TVF Lib "NLW32293E_nag.dll" ( _
    ByRef neq As long, _
    ByRef m As long, _
    ByRef nlbc As long, _
    ByRef nrbc As long, _
    ByRef ncol As long, _
    ByRef tols As double, _
    ByRef mxmesh As long, _
    ByRef nmesh As long, _
    ByRef mesh As double, _
    ByRef ipmesh As long, _
    ByRef rcomm As double, _
    ByRef lrcomm As long, _
    ByRef icomm As long, _
    ByRef licomm As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02TXF Lib "NLW32293E_nag.dll" ( _
    ByRef mxmesh As long, _
    ByRef nmesh As long, _
    ByRef mesh As double, _
    ByRef ipmesh As long, _
    ByRef rcomm As double, _
    ByRef icomm As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02TYF Lib "NLW32293E_nag.dll" ( _
    ByRef x As double, _
    ByRef y As double, _
    ByRef neq As long, _
    ByRef mmax As long, _
    ByRef rcomm As double, _
    ByRef icomm As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02TZF Lib "NLW32293E_nag.dll" ( _
    ByRef mxmesh As long, _
    ByRef nmesh As long, _
    ByRef mesh As double, _
    ByRef ipmesh As long, _
    ByRef ermx As double, _
    ByRef iermx As long, _
    ByRef ijermx As long, _
    ByRef rcomm As double, _
    ByRef icomm As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02UAF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef f As double, _
    ByRef c As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02UBF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef q As long, _
    ByRef c As double, _
    ByRef f As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02UCF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef x As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02UDF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef f As double, _
    ByRef fd As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02UEF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef m As long, _
    ByRef c As double, _
    ByRef bmat As double, _
    ByRef y As double, _
    ByRef bvec As double, _
    ByRef f As double, _
    ByRef uc As double, _
    ByRef resid As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02UWF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef nip As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef xip As double, _
    ByRef fip As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02UYF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef w As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02UZF Lib "NLW32293E_nag.dll" ( _
    ByRef k As long, _
    ByRef x As double, _
    ByRef t As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02XJF Lib "NLW32293E_nag.dll" ( _
    ByRef xsol As double, _
    ByRef sol As double, _
    ByRef m As long, _
    ByRef ysav As double, _
    ByRef ldysav As long, _
    ByRef sdysav As long, _
    ByRef neq As long, _
    ByRef x As double, _
    ByRef nqu As long, _
    ByRef hu As double, _
    ByRef h As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D02XKF Lib "NLW32293E_nag.dll" ( _
    ByRef xsol As double, _
    ByRef sol As double, _
    ByRef m As long, _
    ByRef ysav As double, _
    ByRef ldysav As long, _
    ByRef sdysav As long, _
    ByRef acor As double, _
    ByRef neq As long, _
    ByRef x As double, _
    ByRef nqu As long, _
    ByRef hu As double, _
    ByRef h As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Function D02ZAF Lib "NLW32293E_nag.dll" ( _
    ByRef neq As long, _
    ByRef v As double, _
    ByRef w As double, _
    ByRef ifail As long _
   ) As double


' chapter d03

   Declare Ptrsafe Sub D03EAF Lib "NLW32293E_nag.dll" ( _
    ByRef stage1 As long, _
    ByRef ext As long, _
    ByRef dorm As long, _
    ByRef n As long, _
    ByRef p As double, _
    ByRef q As double, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef n1p1 As long, _
    ByRef phi As double, _
    ByRef phid As double, _
    ByRef alpha As double, _
    ByRef c As double, _
    ByRef ldc As long, _
    ByRef np4 As long, _
    ByRef icint As long, _
    ByRef np1 As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D03EBF Lib "NLW32293E_nag.dll" ( _
    ByRef n1 As long, ByRef n2 As long, ByRef lda As long, _
    ByRef a As double, ByRef b As double, ByRef c As double, _
    ByRef d As double, ByRef e As double, ByRef q As double, _
    ByRef t As double, ByRef aparam As double, ByRef itmax As long, _
    ByRef itcoun As long, ByRef itused As long, ByRef ndir As long, _
    ByRef ixn As long, ByRef iyn As long, ByRef conres As double, _
    ByRef conchn As double, ByRef resids As double, ByRef chngs As double, _
    ByRef wrksp1 As double, ByRef wrksp2 As double, ByRef wrksp3 As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D03ECF Lib "NLW32293E_nag.dll" ( _
    ByRef n1 As long, ByRef n2 As long, ByRef n3 As long, _
    ByRef lda As long, ByRef sda As long, ByRef a As double, _
    ByRef b As double, ByRef c As double, ByRef d As double, _
    ByRef e As double, ByRef f As double, ByRef g As double, _
    ByRef q As double, ByRef t As double, ByRef aparam As double, _
    ByRef itmax As long, ByRef itcoun As long, ByRef itused As long, _
    ByRef ndir As long, ByRef ixn As long, ByRef iyn As long, _
    ByRef izn As long, ByRef conres As double, ByRef conchn As double, _
    ByRef resids As double, ByRef chngs As double, ByRef wrksp1 As double, _
    ByRef wrksp2 As double, ByRef wrksp3 As double, ByRef wrksp4 As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D03EDF Lib "NLW32293E_nag.dll" ( _
    ByRef ngx As long, _
    ByRef ngy As long, _
    ByRef lda As long, _
    ByRef a As double, _
    ByRef rhs As double, _
    ByRef ub As double, _
    ByRef maxit As long, _
    ByRef acc As double, _
    ByRef us As double, _
    ByRef u As double, _
    ByRef iout As long, _
    ByRef numit As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D03EEF_PDEF( _
'      ByRef x As double, _
'      ByRef y As double, _
'      ByRef alpha As double, _
'      ByRef beta As double, _
'      ByRef gamma As double, _
'      ByRef delta As double, _
'      ByRef epslon As double, _
'      ByRef phi As double, _
'      ByRef psi As double _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03EEF_BNDY( _
'      ByRef x As double, _
'      ByRef y As double, _
'      ByRef a As double, _
'      ByRef b As double, _
'      ByRef c As double, _
'      ByRef ibnd As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D03EEF Lib "NLW32293E_nag.dll" ( _
    ByRef xmin As double, _
    ByRef xmax As double, _
    ByRef ymin As double, _
    ByRef ymax As double, _
    ByVal pdef As longPtr, _
    ByVal bndy As longPtr, _
    ByRef ngx As long, _
    ByRef ngy As long, _
    ByRef lda As long, _
    ByRef a As double, _
    ByRef rhs As double, _
    ByVal scheme As string, ByVal schemelength As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D03FAF Lib "NLW32293E_nag.dll" ( _
    ByRef xs As double, ByRef xf As double, ByRef l As long, _
    ByRef lbdcnd As long, ByRef bdxs As double, ByRef bdxf As double, _
    ByRef ys As double, ByRef yf As double, ByRef m As long, _
    ByRef mbdcnd As long, ByRef bdys As double, ByRef bdyf As double, _
    ByRef zs As double, ByRef zf As double, ByRef n As long, _
    ByRef nbdcnd As long, ByRef bdzs As double, ByRef bdzf As double, _
    ByRef lambda As double, ByRef ldf As long, ByRef ldf2 As long, _
    ByRef f As double, ByRef pertrb As double, ByRef w As double, _
    ByRef lwrk As long, ByRef ifail As long _
   )


' skeleton code for callback function
'  Function D03MAF_ISIN( _
'      ByRef x As double, _
'      ByRef y As double _
'    ) As long
'      ' your code here
'  End Function

   Declare Ptrsafe Sub D03MAF Lib "NLW32293E_nag.dll" ( _
    ByRef h As double, _
    ByRef m As long, _
    ByRef n As long, _
    ByRef nb As long, _
    ByRef npts As long, _
    ByRef places As double, _
    ByRef indx As long, _
    ByRef sdindx As long, _
    ByVal isin As longPtr, _
    ByRef dist As double, _
    ByRef sddist As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D03NCF Lib "NLW32293E_nag.dll" ( _
    ByRef kopt As long, ByRef x As double, ByVal mesh As string, ByVal meshlength As long, _
    ByRef ns As long, ByRef s As double, ByRef nt As long, _
    ByRef t As double, ByRef tdpar As long, ByRef r As double, _
    ByRef q As double, ByRef sigma As double, ByRef alpha As double, _
    ByRef ntkeep As long, ByRef f As double, ByRef theta As double, _
    ByRef delta As double, ByRef gamma As double, ByRef lambda As double, _
    ByRef rho As double, ByRef ldf As long, ByRef work As double, _
    ByRef iwork As long, ByRef ifail As long _
   )


   Declare Ptrsafe Sub D03NDF Lib "NLW32293E_nag.dll" ( _
    ByRef kopt As long, _
    ByRef x As double, _
    ByRef s As double, _
    ByRef t As double, _
    ByRef tmat As double, _
    ByRef tdpar As long, _
    ByRef r As double, _
    ByRef q As double, _
    ByRef sigma As double, _
    ByRef f As double, _
    ByRef theta As double, _
    ByRef delta As double, _
    ByRef gamma As double, _
    ByRef lambda As double, _
    ByRef rho As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D03NEF Lib "NLW32293E_nag.dll" ( _
    ByRef t0 As double, _
    ByRef tmat As double, _
    ByRef ntd As long, _
    ByRef td As double, _
    ByRef phid As double, _
    ByRef phiav As double, _
    ByRef work As double, _
    ByRef lwork As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D03PCA_PDEDEF( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByRef x As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByVal p_rptr As longPtr, _
'      ByVal q_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByRef ires As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PCA_BNDARY( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByRef ibnd As long, _
'      ByVal beta_rptr As longPtr, _
'      ByVal gamma_rptr As longPtr, _
'      ByRef ires As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D03PCA Lib "NLW32293E_nag.dll" ( _
    ByRef npde As long, ByRef m As long, ByRef ts As double, _
    ByRef tout As double, ByVal pdedef As longPtr, _
    ByVal bndary As longPtr, _
    ByRef u As double, ByRef npts As long, ByRef x As double, _
    ByRef acc As double, ByRef rsave As double, ByRef lrsave As long, _
    ByRef isave As long, ByRef lisave As long, ByRef itask As long, _
    ByRef itrace As long, ByRef ind As long, ByRef iuser As long, _
    ByRef ruser As double, ByVal cwsav As string, ByVal cwsavlength As long, ByRef lwsav As long, _
    ByRef iwsav As long, ByRef rwsav As double, ByRef ifail As long _
   )

' skeleton code for callback function
'  Sub D03PCF_PDEDEF( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByRef x As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByVal p_rptr As longPtr, _
'      ByVal q_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PCF_BNDARY( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByRef ibnd As long, _
'      ByVal beta_rptr As longPtr, _
'      ByVal gamma_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D03PCF Lib "NLW32293E_nag.dll" ( _
    ByRef npde As long, _
    ByRef m As long, _
    ByRef ts As double, _
    ByRef tout As double, _
    ByVal pdedef As longPtr, _
    ByVal bndary As longPtr, _
    ByRef u As double, _
    ByRef npts As long, _
    ByRef x As double, _
    ByRef acc As double, _
    ByRef rsave As double, _
    ByRef lrsave As long, _
    ByRef isave As long, _
    ByRef lisave As long, _
    ByRef itask As long, _
    ByRef itrace As long, _
    ByRef ind As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D53PCK Lib "NLW32293E_nag.dll" ( _
    ByRef npde As long, _
    ByRef t As double, _
    ByRef nv As long, _
    ByRef v As double, _
    ByRef vdot As double, _
    ByRef nxi As long, _
    ByRef xi As double, _
    ByRef ucp As double, _
    ByRef ucpx As double, _
    ByRef rcp As double, _
    ByRef ucpt As double, _
    ByRef ucptx As double, _
    ByRef f As double, _
    ByRef ires As long, _
    ByRef iuser As long, _
    ByRef ruser As double _
   )

   Declare Ptrsafe Sub D03PCK Lib "NLW32293E_nag.dll" ( _
    ByRef npde As long, _
    ByRef t As double, _
    ByRef nv As long, _
    ByRef v As double, _
    ByRef vdot As double, _
    ByRef nxi As long, _
    ByRef xi As double, _
    ByRef ucp As double, _
    ByRef ucpx As double, _
    ByRef rcp As double, _
    ByRef ucpt As double, _
    ByRef ucptx As double, _
    ByRef f As double, _
    ByRef ires As long _
   )


   Declare Ptrsafe Sub D53PCL Lib "NLW32293E_nag.dll" ( _
    ByRef t As double, _
    ByRef npts As long, _
    ByRef npde As long, _
    ByRef x As double, _
    ByRef u As double, _
    ByRef r As double, _
    ByRef fmon As double, _
    ByRef iuser As long, _
    ByRef ruser As double _
   )

   Declare Ptrsafe Sub D03PCL Lib "NLW32293E_nag.dll" ( _
    ByRef t As double, _
    ByRef npts As long, _
    ByRef npde As long, _
    ByRef x As double, _
    ByRef u As double, _
    ByRef r As double, _
    ByRef fmon As double _
   )


' skeleton code for callback function
'  Sub D03PDA_PDEDEF( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByVal x_rptr As longPtr, _
'      ByRef nptl As long, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByVal p_rptr As longPtr, _
'      ByVal q_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByRef ires As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PDA_BNDARY( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByRef ibnd As long, _
'      ByVal beta_rptr As longPtr, _
'      ByVal gamma_rptr As longPtr, _
'      ByRef ires As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PDA_UINIT( _
'      ByRef npde As long, _
'      ByRef npts As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal u_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D03PDA Lib "NLW32293E_nag.dll" ( _
    ByRef npde As long, ByRef m As long, ByRef ts As double, _
    ByRef tout As double, ByVal pdedef As longPtr, _
    ByVal bndary As longPtr, _
    ByRef u As double, ByRef nbkpts As long, ByRef xbkpts As double, _
    ByRef npoly As long, ByRef npts As long, ByRef x As double, _
    ByVal uinit As longPtr, _
    ByRef acc As double, ByRef rsave As double, _
    ByRef lrsave As long, ByRef isave As long, ByRef lisave As long, _
    ByRef itask As long, ByRef itrace As long, ByRef ind As long, _
    ByRef iuser As long, ByRef ruser As double, ByVal cwsav As string, ByVal cwsavlength As long, _
    ByRef lwsav As long, ByRef iwsav As long, ByRef rwsav As double, _
    ByRef ifail As long _
   )

' skeleton code for callback function
'  Sub D03PDF_PDEDEF( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByVal x_rptr As longPtr, _
'      ByRef nptl As long, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByVal p_rptr As longPtr, _
'      ByVal q_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PDF_BNDARY( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByRef ibnd As long, _
'      ByVal beta_rptr As longPtr, _
'      ByVal gamma_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PDF_UINIT( _
'      ByRef npde As long, _
'      ByRef npts As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal u_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D03PDF Lib "NLW32293E_nag.dll" ( _
    ByRef npde As long, ByRef m As long, ByRef ts As double, _
    ByRef tout As double, ByVal pdedef As longPtr, _
    ByVal bndary As longPtr, _
    ByRef u As double, ByRef nbkpts As long, ByRef xbkpts As double, _
    ByRef npoly As long, ByRef npts As long, ByRef x As double, _
    ByVal uinit As longPtr, _
    ByRef acc As double, ByRef rsave As double, _
    ByRef lrsave As long, ByRef isave As long, ByRef lisave As long, _
    ByRef itask As long, ByRef itrace As long, ByRef ind As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D03PEF_PDEDEF( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByRef x As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ut_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByVal res_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PEF_BNDARY( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByRef ibnd As long, _
'      ByRef nobc As long, _
'      ByVal u_rptr As longPtr, _
'      ByVal ut_rptr As longPtr, _
'      ByVal res_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D03PEF Lib "NLW32293E_nag.dll" ( _
    ByRef npde As long, _
    ByRef ts As double, _
    ByRef tout As double, _
    ByVal pdedef As longPtr, _
    ByVal bndary As longPtr, _
    ByRef u As double, _
    ByRef npts As long, _
    ByRef x As double, _
    ByRef nleft As long, _
    ByRef acc As double, _
    ByRef rsave As double, _
    ByRef lrsave As long, _
    ByRef isave As long, _
    ByRef lisave As long, _
    ByRef itask As long, _
    ByRef itrace As long, _
    ByRef ind As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D03PEK Lib "NLW32293E_nag.dll" ( _
    ByRef npde As long, _
    ByRef t As double, _
    ByRef nv As long, _
    ByRef v As double, _
    ByRef vdot As double, _
    ByRef nxi As long, _
    ByRef xi As double, _
    ByRef ucp As double, _
    ByRef ucpx As double, _
    ByRef ucpt As double, _
    ByRef r As double, _
    ByRef ires As long _
   )


   Declare Ptrsafe Sub D03PEL Lib "NLW32293E_nag.dll" ( _
    ByRef t As double, _
    ByRef npts As long, _
    ByRef npde As long, _
    ByRef x As double, _
    ByRef u As double, _
    ByRef fmon As double _
   )


' skeleton code for callback function
'  Sub D03PFF_PDEDEF( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByRef x As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByVal p_rptr As longPtr, _
'      ByVal c_rptr As longPtr, _
'      ByVal d_rptr As longPtr, _
'      ByVal s_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D03PFP Lib "NLW32293E_nag.dll" ( _
    ByRef npde As long, _
    ByRef t As double, _
    ByRef x As double, _
    ByVal u_rptr As longPtr, _
    ByVal ux_rptr As longPtr, _
    ByVal p_rptr As longPtr, _
    ByVal c_rptr As longPtr, _
    ByVal d_rptr As longPtr, _
    ByVal s_rptr As longPtr, _
    ByRef ires As long _
  )

' skeleton code for callback function
'  Sub D03PFF_NUMFLX( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByRef x As double, _
'      ByVal uleft_rptr As longPtr, _
'      ByVal uright_rptr As longPtr, _
'      ByVal flux_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PFF_BNDARY( _
'      ByRef npde As long, _
'      ByRef npts As long, _
'      ByRef t As double, _
'      ByVal x_rptr As longPtr, _
'      ByVal u_rptr As longPtr, _
'      ByRef ibnd As long, _
'      ByVal g_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D03PFF Lib "NLW32293E_nag.dll" ( _
    ByRef npde As long, _
    ByRef ts As double, _
    ByRef tout As double, _
    ByVal pdedef As longPtr, _
    ByVal numflx As longPtr, _
    ByVal bndary As longPtr, _
    ByRef u As double, _
    ByRef npts As long, _
    ByRef x As double, _
    ByRef acc As double, _
    ByRef tsmax As double, _
    ByRef rsave As double, _
    ByRef lrsave As long, _
    ByRef isave As long, _
    ByRef lisave As long, _
    ByRef itask As long, _
    ByRef itrace As long, _
    ByRef ind As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D03PHA_PDEDEF( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByRef x As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal p_rptr As longPtr, _
'      ByVal q_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByRef ires As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PHA_BNDARY( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByRef ibnd As long, _
'      ByVal beta_rptr As longPtr, _
'      ByVal gamma_rptr As longPtr, _
'      ByRef ires As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PHA_ODEDEF( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByRef nxi As long, _
'      ByVal xi_rptr As longPtr, _
'      ByVal ucp_rptr As longPtr, _
'      ByVal ucpx_rptr As longPtr, _
'      ByVal rcp_rptr As longPtr, _
'      ByVal ucpt_rptr As longPtr, _
'      ByVal ucptx_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByRef ires As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub D03PHA Lib "NLW32293E_nag.dll" ( _
    ByRef npde As long, ByRef m As long, ByRef ts As double, _
    ByRef tout As double, ByVal pdedef As longPtr, _
    ByVal bndary As longPtr, _
    ByRef u As double, ByRef npts As long, ByRef x As double, _
    ByRef nv As long, ByVal odedef As longPtr, _
    ByRef nxi As long, _
    ByRef xi As double, ByRef neqn As long, ByRef rtol As double, _
    ByRef atol As double, ByRef itol As long, ByVal norm As string, ByVal normlength As long, _
    ByVal laopt As string, ByVal laoptlength As long, ByRef algopt As double, ByRef rsave As double, _
    ByRef lrsave As long, ByRef isave As long, ByRef lisave As long, _
    ByRef itask As long, ByRef itrace As long, ByRef ind As long, _
    ByRef iuser As long, ByRef ruser As double, ByVal cwsav As string, ByVal cwsavlength As long, _
    ByRef lwsav As long, ByRef iwsav As long, ByRef rwsav As double, _
    ByRef ifail As long _
   )

' skeleton code for callback function
'  Sub D03PHF_PDEDEF( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByRef x As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal p_rptr As longPtr, _
'      ByVal q_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PHF_BNDARY( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByRef ibnd As long, _
'      ByVal beta_rptr As longPtr, _
'      ByVal gamma_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PHF_ODEDEF( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByRef nxi As long, _
'      ByVal xi_rptr As longPtr, _
'      ByVal ucp_rptr As longPtr, _
'      ByVal ucpx_rptr As longPtr, _
'      ByVal rcp_rptr As longPtr, _
'      ByVal ucpt_rptr As longPtr, _
'      ByVal ucptx_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub D03PHF Lib "NLW32293E_nag.dll" ( _
    ByRef npde As long, ByRef m As long, ByRef ts As double, _
    ByRef tout As double, ByVal pdedef As longPtr, _
    ByVal bndary As longPtr, _
    ByRef u As double, ByRef npts As long, ByRef x As double, _
    ByRef nv As long, ByVal odedef As longPtr, _
    ByRef nxi As long, _
    ByRef xi As double, ByRef neqn As long, ByRef rtol As double, _
    ByRef atol As double, ByRef itol As long, ByVal norm As string, ByVal normlength As long, _
    ByVal laopt As string, ByVal laoptlength As long, ByRef algopt As double, ByRef rsave As double, _
    ByRef lrsave As long, ByRef isave As long, ByRef lisave As long, _
    ByRef itask As long, ByRef itrace As long, ByRef ind As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D03PJA_PDEDEF( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByVal x_rptr As longPtr, _
'      ByRef nptl As long, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal p_rptr As longPtr, _
'      ByVal q_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByRef ires As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PJA_BNDARY( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByRef ibnd As long, _
'      ByVal beta_rptr As longPtr, _
'      ByVal gamma_rptr As longPtr, _
'      ByRef ires As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PJA_ODEDEF( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByRef nxi As long, _
'      ByVal xi_rptr As longPtr, _
'      ByVal ucp_rptr As longPtr, _
'      ByVal ucpx_rptr As longPtr, _
'      ByVal rcp_rptr As longPtr, _
'      ByVal ucpt_rptr As longPtr, _
'      ByVal ucptx_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByRef ires As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub D03PJA_UVINIT( _
'      ByRef npde As long, _
'      ByRef npts As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal u_rptr As longPtr, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D03PJA Lib "NLW32293E_nag.dll" ( _
    ByRef npde As long, ByRef m As long, ByRef ts As double, _
    ByRef tout As double, ByVal pdedef As longPtr, _
    ByVal bndary As longPtr, _
    ByRef u As double, ByRef nbkpts As long, ByRef xbkpts As double, _
    ByRef npoly As long, ByRef npts As long, ByRef x As double, _
    ByRef nv As long, ByVal odedef As longPtr, _
    ByRef nxi As long, _
    ByRef xi As double, ByRef neqn As long, ByVal uvinit As longPtr, _
    ByRef rtol As double, ByRef atol As double, ByRef itol As long, _
    ByVal norm As string, ByVal normlength As long, ByVal laopt As string, ByVal laoptlength As long, ByRef algopt As double, _
    ByRef rsave As double, ByRef lrsave As long, ByRef isave As long, _
    ByRef lisave As long, ByRef itask As long, ByRef itrace As long, _
    ByRef ind As long, ByRef iuser As long, ByRef ruser As double, _
    ByVal cwsav As string, ByVal cwsavlength As long, ByRef lwsav As long, ByRef iwsav As long, _
    ByRef rwsav As double, ByRef ifail As long _
   )

' skeleton code for callback function
'  Sub D03PJF_PDEDEF( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByVal x_rptr As longPtr, _
'      ByRef nptl As long, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal p_rptr As longPtr, _
'      ByVal q_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PJF_BNDARY( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByRef ibnd As long, _
'      ByVal beta_rptr As longPtr, _
'      ByVal gamma_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PJF_ODEDEF( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByRef nxi As long, _
'      ByVal xi_rptr As longPtr, _
'      ByVal ucp_rptr As longPtr, _
'      ByVal ucpx_rptr As longPtr, _
'      ByVal rcp_rptr As longPtr, _
'      ByVal ucpt_rptr As longPtr, _
'      ByVal ucptx_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub D03PJF_UVINIT( _
'      ByRef npde As long, _
'      ByRef npts As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal u_rptr As longPtr, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D03PJF Lib "NLW32293E_nag.dll" ( _
    ByRef npde As long, ByRef m As long, ByRef ts As double, _
    ByRef tout As double, ByVal pdedef As longPtr, _
    ByVal bndary As longPtr, _
    ByRef u As double, ByRef nbkpts As long, ByRef xbkpts As double, _
    ByRef npoly As long, ByRef npts As long, ByRef x As double, _
    ByRef nv As long, ByVal odedef As longPtr, _
    ByRef nxi As long, _
    ByRef xi As double, ByRef neqn As long, ByVal uvinit As longPtr, _
    ByRef rtol As double, ByRef atol As double, ByRef itol As long, _
    ByVal norm As string, ByVal normlength As long, ByVal laopt As string, ByVal laoptlength As long, ByRef algopt As double, _
    ByRef rsave As double, ByRef lrsave As long, ByRef isave As long, _
    ByRef lisave As long, ByRef itask As long, ByRef itrace As long, _
    ByRef ind As long, ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D03PKF_PDEDEF( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByRef x As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ut_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal res_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PKF_BNDARY( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByRef ibnd As long, _
'      ByRef nobc As long, _
'      ByVal u_rptr As longPtr, _
'      ByVal ut_rptr As longPtr, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal res_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PKF_ODEDEF( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByRef nxi As long, _
'      ByVal xi_rptr As longPtr, _
'      ByVal ucp_rptr As longPtr, _
'      ByVal ucpx_rptr As longPtr, _
'      ByVal ucpt_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub D03PKF Lib "NLW32293E_nag.dll" ( _
    ByRef npde As long, ByRef ts As double, ByRef tout As double, _
    ByVal pdedef As longPtr, _
    ByVal bndary As longPtr, ByRef u As double, _
    ByRef npts As long, ByRef x As double, ByRef nleft As long, _
    ByRef nv As long, ByVal odedef As longPtr, _
    ByRef nxi As long, _
    ByRef xi As double, ByRef neqn As long, ByRef rtol As double, _
    ByRef atol As double, ByRef itol As long, ByVal norm As string, ByVal normlength As long, _
    ByVal laopt As string, ByVal laoptlength As long, ByRef algopt As double, ByRef rsave As double, _
    ByRef lrsave As long, ByRef isave As long, ByRef lisave As long, _
    ByRef itask As long, ByRef itrace As long, ByRef ind As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D03PLF_PDEDEF( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByRef x As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal p_rptr As longPtr, _
'      ByVal c_rptr As longPtr, _
'      ByVal d_rptr As longPtr, _
'      ByVal s_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D03PLP Lib "NLW32293E_nag.dll" ( _
    ByRef npde As long, _
    ByRef t As double, _
    ByRef x As double, _
    ByVal u_rptr As longPtr, _
    ByVal ux_rptr As longPtr, _
    ByRef nv As long, _
    ByVal v_rptr As longPtr, _
    ByVal vdot_rptr As longPtr, _
    ByVal p_rptr As longPtr, _
    ByVal c_rptr As longPtr, _
    ByVal d_rptr As longPtr, _
    ByVal s_rptr As longPtr, _
    ByRef ires As long _
  )

' skeleton code for callback function
'  Sub D03PLF_NUMFLX( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByRef x As double, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal uleft_rptr As longPtr, _
'      ByVal uright_rptr As longPtr, _
'      ByVal flux_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PLF_BNDARY( _
'      ByRef npde As long, _
'      ByRef npts As long, _
'      ByRef t As double, _
'      ByVal x_rptr As longPtr, _
'      ByVal u_rptr As longPtr, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByRef ibnd As long, _
'      ByVal g_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PLF_ODEDEF( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByRef nxi As long, _
'      ByVal xi_rptr As longPtr, _
'      ByVal ucp_rptr As longPtr, _
'      ByVal ucpx_rptr As longPtr, _
'      ByVal ucpt_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub D03PLF Lib "NLW32293E_nag.dll" ( _
    ByRef npde As long, ByRef ts As double, ByRef tout As double, _
    ByVal pdedef As longPtr, _
    ByVal numflx As longPtr, _
    ByVal bndary As longPtr, _
    ByRef u As double, ByRef npts As long, ByRef x As double, _
    ByRef nv As long, ByVal odedef As longPtr, _
    ByRef nxi As long, _
    ByRef xi As double, ByRef neqn As long, ByRef rtol As double, _
    ByRef atol As double, ByRef itol As long, ByVal norm As string, ByVal normlength As long, _
    ByVal laopt As string, ByVal laoptlength As long, ByRef algopt As double, ByRef rsave As double, _
    ByRef lrsave As long, ByRef isave As long, ByRef lisave As long, _
    ByRef itask As long, ByRef itrace As long, ByRef ind As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D03PPA_PDEDEF( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByRef x As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal p_rptr As longPtr, _
'      ByVal q_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByRef ires As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PPA_BNDARY( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByRef ibnd As long, _
'      ByVal beta_rptr As longPtr, _
'      ByVal gamma_rptr As longPtr, _
'      ByRef ires As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PPA_UVINIT( _
'      ByRef npde As long, _
'      ByRef npts As long, _
'      ByRef nxi As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal xi_rptr As longPtr, _
'      ByVal u_rptr As longPtr, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PPA_ODEDEF( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByRef nxi As long, _
'      ByVal xi_rptr As longPtr, _
'      ByVal ucp_rptr As longPtr, _
'      ByVal ucpx_rptr As longPtr, _
'      ByVal rcp_rptr As longPtr, _
'      ByVal ucpt_rptr As longPtr, _
'      ByVal ucptx_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByRef ires As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub D03PPA_MONITF( _
'      ByRef t As double, _
'      ByRef npts As long, _
'      ByRef npde As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal u_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByVal fmon_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub D03PPA Lib "NLW32293E_nag.dll" ( _
    ByRef npde As long, ByRef m As long, ByRef ts As double, _
    ByRef tout As double, ByVal pdedef As longPtr, _
    ByVal bndary As longPtr, _
    ByVal uvinit As longPtr, ByRef u As double, ByRef npts As long, _
    ByRef x As double, ByRef nv As long, ByVal odedef As longPtr, _
    ByRef nxi As long, ByRef xi As double, ByRef neqn As long, _
    ByRef rtol As double, ByRef atol As double, ByRef itol As long, _
    ByVal norm As string, ByVal normlength As long, ByVal laopt As string, ByVal laoptlength As long, ByRef algopt As double, _
    ByRef remesh As long, ByRef nxfix As long, ByRef xfix As double, _
    ByRef nrmesh As long, ByRef dxmesh As double, ByRef trmesh As double, _
    ByRef ipminf As long, ByRef xratio As double, ByRef con As double, _
    ByVal monitf As longPtr, ByRef rsave As double, ByRef lrsave As long, _
    ByRef isave As long, ByRef lisave As long, ByRef itask As long, _
    ByRef itrace As long, ByRef ind As long, ByRef iuser As long, _
    ByRef ruser As double, ByVal cwsav As string, ByVal cwsavlength As long, ByRef lwsav As long, _
    ByRef iwsav As long, ByRef rwsav As double, ByRef ifail As long _
   )

' skeleton code for callback function
'  Sub D03PPF_PDEDEF( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByRef x As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal p_rptr As longPtr, _
'      ByVal q_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PPF_BNDARY( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByRef ibnd As long, _
'      ByVal beta_rptr As longPtr, _
'      ByVal gamma_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PPF_UVINIT( _
'      ByRef npde As long, _
'      ByRef npts As long, _
'      ByRef nxi As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal xi_rptr As longPtr, _
'      ByVal u_rptr As longPtr, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PPF_ODEDEF( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByRef nxi As long, _
'      ByVal xi_rptr As longPtr, _
'      ByVal ucp_rptr As longPtr, _
'      ByVal ucpx_rptr As longPtr, _
'      ByVal rcp_rptr As longPtr, _
'      ByVal ucpt_rptr As longPtr, _
'      ByVal ucptx_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub D03PPF_MONITF( _
'      ByRef t As double, _
'      ByRef npts As long, _
'      ByRef npde As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal u_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByVal fmon_rptr As longPtr _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub D03PPF Lib "NLW32293E_nag.dll" ( _
    ByRef npde As long, ByRef m As long, ByRef ts As double, _
    ByRef tout As double, ByVal pdedef As longPtr, _
    ByVal bndary As longPtr, _
    ByVal uvinit As longPtr, ByRef u As double, ByRef npts As long, _
    ByRef x As double, ByRef nv As long, ByVal odedef As longPtr, _
    ByRef nxi As long, ByRef xi As double, ByRef neqn As long, _
    ByRef rtol As double, ByRef atol As double, ByRef itol As long, _
    ByVal norm As string, ByVal normlength As long, ByVal laopt As string, ByVal laoptlength As long, ByRef algopt As double, _
    ByRef remesh As long, ByRef nxfix As long, ByRef xfix As double, _
    ByRef nrmesh As long, ByRef dxmesh As double, ByRef trmesh As double, _
    ByRef ipminf As long, ByRef xratio As double, ByRef con As double, _
    ByVal monitf As longPtr, ByRef rsave As double, ByRef lrsave As long, _
    ByRef isave As long, ByRef lisave As long, ByRef itask As long, _
    ByRef itrace As long, ByRef ind As long, ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D03PRF_PDEDEF( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByRef x As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ut_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal res_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PRF_BNDARY( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByRef ibnd As long, _
'      ByRef nobc As long, _
'      ByVal u_rptr As longPtr, _
'      ByVal ut_rptr As longPtr, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal res_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PRF_UVINIT( _
'      ByRef npde As long, _
'      ByRef npts As long, _
'      ByRef nxi As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal xi_rptr As longPtr, _
'      ByVal u_rptr As longPtr, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PRF_ODEDEF( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByRef nxi As long, _
'      ByVal xi_rptr As longPtr, _
'      ByVal ucp_rptr As longPtr, _
'      ByVal ucpx_rptr As longPtr, _
'      ByVal ucpt_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub D03PRF_MONITF( _
'      ByRef t As double, _
'      ByRef npts As long, _
'      ByRef npde As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal u_rptr As longPtr, _
'      ByVal fmon_rptr As longPtr _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub D03PRF Lib "NLW32293E_nag.dll" ( _
    ByRef npde As long, ByRef ts As double, ByRef tout As double, _
    ByVal pdedef As longPtr, _
    ByVal bndary As longPtr, _
    ByVal uvinit As longPtr, _
    ByRef u As double, ByRef npts As long, ByRef x As double, _
    ByRef nleft As long, ByRef nv As long, ByVal odedef As longPtr, _
    ByRef nxi As long, ByRef xi As double, ByRef neqn As long, _
    ByRef rtol As double, ByRef atol As double, ByRef itol As long, _
    ByVal norm As string, ByVal normlength As long, ByVal laopt As string, ByVal laoptlength As long, ByRef algopt As double, _
    ByRef remesh As long, ByRef nxfix As long, ByRef xfix As double, _
    ByRef nrmesh As long, ByRef dxmesh As double, ByRef trmesh As double, _
    ByRef ipminf As long, ByRef xratio As double, ByRef con As double, _
    ByVal monitf As longPtr, ByRef rsave As double, ByRef lrsave As long, _
    ByRef isave As long, ByRef lisave As long, ByRef itask As long, _
    ByRef itrace As long, ByRef ind As long, ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D03PSF_PDEDEF( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByRef x As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal p_rptr As longPtr, _
'      ByVal c_rptr As longPtr, _
'      ByVal d_rptr As longPtr, _
'      ByVal s_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub D03PSF_NUMFLX( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByRef x As double, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal uleft_rptr As longPtr, _
'      ByVal uright_rptr As longPtr, _
'      ByVal flux_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PSF_BNDARY( _
'      ByRef npde As long, _
'      ByRef npts As long, _
'      ByRef t As double, _
'      ByVal x_rptr As longPtr, _
'      ByVal u_rptr As longPtr, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByRef ibnd As long, _
'      ByVal g_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PSF_UVINIT( _
'      ByRef npde As long, _
'      ByRef npts As long, _
'      ByRef nxi As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal xi_rptr As longPtr, _
'      ByVal u_rptr As longPtr, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03PSF_ODEDEF( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByRef nv As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByRef nxi As long, _
'      ByVal xi_rptr As longPtr, _
'      ByVal ucp_rptr As longPtr, _
'      ByVal ucpx_rptr As longPtr, _
'      ByVal ucpt_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByRef ires As long _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub D03PSF_MONITF( _
'      ByRef t As double, _
'      ByRef npts As long, _
'      ByRef npde As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal u_rptr As longPtr, _
'      ByVal fmon_rptr As longPtr _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub D03PSF Lib "NLW32293E_nag.dll" ( _
    ByRef npde As long, ByRef ts As double, ByRef tout As double, _
    ByVal pdedef As longPtr, _
    ByVal numflx As longPtr, _
    ByVal bndary As longPtr, _
    ByVal uvinit As longPtr, ByRef u As double, ByRef npts As long, _
    ByRef x As double, ByRef nv As long, ByVal odedef As longPtr, _
    ByRef nxi As long, ByRef xi As double, ByRef neqn As long, _
    ByRef rtol As double, ByRef atol As double, ByRef itol As long, _
    ByVal norm As string, ByVal normlength As long, ByVal laopt As string, ByVal laoptlength As long, ByRef algopt As double, _
    ByRef remesh As long, ByRef nxfix As long, ByRef xfix As double, _
    ByRef nrmesh As long, ByRef dxmesh As double, ByRef trmesh As double, _
    ByRef ipminf As long, ByRef xratio As double, ByRef con As double, _
    ByVal monitf As longPtr, ByRef rsave As double, ByRef lrsave As long, _
    ByRef isave As long, ByRef lisave As long, ByRef itask As long, _
    ByRef itrace As long, ByRef ind As long, ByRef ifail As long _
   )


   Declare Ptrsafe Sub D03PUF Lib "NLW32293E_nag.dll" ( _
    ByRef uleft As double, _
    ByRef uright As double, _
    ByRef gamma As double, _
    ByRef flux As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D03PVF Lib "NLW32293E_nag.dll" ( _
    ByRef uleft As double, _
    ByRef uright As double, _
    ByRef gamma As double, _
    ByVal path As string, ByVal pathlength As long, _
    ByRef flux As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D03PWF Lib "NLW32293E_nag.dll" ( _
    ByRef uleft As double, _
    ByRef uright As double, _
    ByRef gamma As double, _
    ByRef flux As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D03PXF Lib "NLW32293E_nag.dll" ( _
    ByRef uleft As double, _
    ByRef uright As double, _
    ByRef gamma As double, _
    ByRef tol As double, _
    ByRef niter As long, _
    ByRef flux As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D03PYF Lib "NLW32293E_nag.dll" ( _
    ByRef npde As long, _
    ByRef u As double, _
    ByRef nbkpts As long, _
    ByRef xbkpts As double, _
    ByRef npoly As long, _
    ByRef npts As long, _
    ByRef xp As double, _
    ByRef intpts As long, _
    ByRef itype As long, _
    ByRef up As double, _
    ByRef rsave As double, _
    ByRef lrsave As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D03PZF Lib "NLW32293E_nag.dll" ( _
    ByRef npde As long, _
    ByRef m As long, _
    ByRef u As double, _
    ByRef npts As long, _
    ByRef x As double, _
    ByRef xp As double, _
    ByRef intpts As long, _
    ByRef itype As long, _
    ByRef up As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D03RAF_PDEDEF( _
'      ByRef npts As long, _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByVal x_rptr As longPtr, _
'      ByVal y_rptr As longPtr, _
'      ByVal u_rptr As longPtr, _
'      ByVal ut_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByVal uy_rptr As longPtr, _
'      ByVal uxx_rptr As longPtr, _
'      ByVal uxy_rptr As longPtr, _
'      ByVal uyy_rptr As longPtr, _
'      ByVal res_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03RAF_BNDARY( _
'      ByRef npts As long, _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByVal x_rptr As longPtr, _
'      ByVal y_rptr As longPtr, _
'      ByVal u_rptr As longPtr, _
'      ByVal ut_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByVal uy_rptr As longPtr, _
'      ByRef nbpts As long, _
'      ByVal lbnd_iptr As longPtr, _
'      ByVal res_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03RAF_PDEIV( _
'      ByRef npts As long, _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByVal x_rptr As longPtr, _
'      ByVal y_rptr As longPtr, _
'      ByVal u_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03RAF_MONITR( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByRef dt As double, _
'      ByRef dtnew As double, _
'      ByRef tlast As long, _
'      ByRef nlev As long, _
'      ByVal ngpts_iptr As longPtr, _
'      ByVal xpts_rptr As longPtr, _
'      ByVal ypts_rptr As longPtr, _
'      ByVal lsol_iptr As longPtr, _
'      ByVal sol_rptr As longPtr, _
'      ByRef ierr As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D03RAF Lib "NLW32293E_nag.dll" ( _
    ByRef npde As long, ByRef ts As double, ByRef tout As double, _
    ByRef dt As double, ByRef xmin As double, ByRef xmax As double, _
    ByRef ymin As double, ByRef ymax As double, ByRef nx As long, _
    ByRef ny As long, ByRef tols As double, ByRef tolt As double, _
    ByVal pdedef As longPtr, _
    ByVal bndary As longPtr, _
    ByVal pdeiv As longPtr, _
    ByVal monitr As longPtr, ByRef opti As long, ByRef optr As double, _
    ByRef rwk As double, ByRef lenrwk As long, ByRef iwk As long, _
    ByRef leniwk As long, ByRef lwk As long, ByRef lenlwk As long, _
    ByRef itrace As long, ByRef ind As long, ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub D03RBF_INIDOM( _
'      ByRef maxpts As long, _
'      ByRef xmin As double, _
'      ByRef xmax As double, _
'      ByRef ymin As double, _
'      ByRef ymax As double, _
'      ByRef nx As long, _
'      ByRef ny As long, _
'      ByRef npts As long, _
'      ByRef nrows As long, _
'      ByRef nbnds As long, _
'      ByRef nbpts As long, _
'      ByVal lrow_iptr As longPtr, _
'      ByVal irow_iptr As longPtr, _
'      ByVal icol_iptr As longPtr, _
'      ByVal llbnd_iptr As longPtr, _
'      ByVal ilbnd_iptr As longPtr, _
'      ByVal lbnd_iptr As longPtr, _
'      ByRef ierr As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03RBF_PDEDEF( _
'      ByRef npts As long, _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByVal x_rptr As longPtr, _
'      ByVal y_rptr As longPtr, _
'      ByVal u_rptr As longPtr, _
'      ByVal ut_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByVal uy_rptr As longPtr, _
'      ByVal uxx_rptr As longPtr, _
'      ByVal uxy_rptr As longPtr, _
'      ByVal uyy_rptr As longPtr, _
'      ByVal res_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03RBF_BNDARY( _
'      ByRef npts As long, _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByVal x_rptr As longPtr, _
'      ByVal y_rptr As longPtr, _
'      ByVal u_rptr As longPtr, _
'      ByVal ut_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByVal uy_rptr As longPtr, _
'      ByRef nbnds As long, _
'      ByRef nbpts As long, _
'      ByVal llbnd_iptr As longPtr, _
'      ByVal ilbnd_iptr As longPtr, _
'      ByVal lbnd_iptr As longPtr, _
'      ByVal res_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03RBF_PDEIV( _
'      ByRef npts As long, _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByVal x_rptr As longPtr, _
'      ByVal y_rptr As longPtr, _
'      ByVal u_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub D03RBF_MONITR( _
'      ByRef npde As long, _
'      ByRef t As double, _
'      ByRef dt As double, _
'      ByRef dtnew As double, _
'      ByRef tlast As long, _
'      ByRef nlev As long, _
'      ByRef xmin As double, _
'      ByRef ymin As double, _
'      ByRef dxb As double, _
'      ByRef dyb As double, _
'      ByVal lgrid_iptr As longPtr, _
'      ByVal istruc_iptr As longPtr, _
'      ByVal lsol_iptr As longPtr, _
'      ByVal sol_rptr As longPtr, _
'      ByRef ierr As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub D03RBF Lib "NLW32293E_nag.dll" ( _
    ByRef npde As long, ByRef ts As double, ByRef tout As double, _
    ByRef dt As double, ByRef tols As double, ByRef tolt As double, _
    ByVal inidom As longPtr, _
    ByVal pdedef As longPtr, _
    ByVal bndary As longPtr, _
    ByVal pdeiv As longPtr, _
    ByVal monitr As longPtr, ByRef opti As long, _
    ByRef optr As double, ByRef rwk As double, ByRef lenrwk As long, _
    ByRef iwk As long, ByRef leniwk As long, ByRef lwk As long, _
    ByRef lenlwk As long, ByRef itrace As long, ByRef ind As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D03RZF Lib "NLW32293E_nag.dll" ( _
    ByRef level As long, _
    ByRef nlev As long, _
    ByRef xmin As double, _
    ByRef ymin As double, _
    ByRef dxb As double, _
    ByRef dyb As double, _
    ByRef lgrid As long, _
    ByRef istruc As long, _
    ByRef npts As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef lenxy As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D03UAF Lib "NLW32293E_nag.dll" ( _
    ByRef n1 As long, _
    ByRef n2 As long, _
    ByRef lda As long, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef c As double, _
    ByRef d As double, _
    ByRef e As double, _
    ByRef aparam As double, _
    ByRef it As long, _
    ByRef r As double, _
    ByRef wrksp1 As double, _
    ByRef wrksp2 As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D03UBF Lib "NLW32293E_nag.dll" ( _
    ByRef n1 As long, _
    ByRef n2 As long, _
    ByRef n3 As long, _
    ByRef lda As long, _
    ByRef sda As long, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef c As double, _
    ByRef d As double, _
    ByRef e As double, _
    ByRef f As double, _
    ByRef g As double, _
    ByRef aparam As double, _
    ByRef it As long, _
    ByRef r As double, _
    ByRef wrksp1 As double, _
    ByRef wrksp2 As double, _
    ByRef wrksp3 As double, _
    ByRef ifail As long _
   )


' chapter d04

' skeleton code for callback function
'  Function D04AAF_F( _
'      ByRef x As double _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub D04AAF Lib "NLW32293E_nag.dll" ( _
    ByRef xval As double, _
    ByRef nder As long, _
    ByRef hbase As double, _
    ByRef der As double, _
    ByRef erest As double, _
    ByVal f As longPtr, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D04BAF Lib "NLW32293E_nag.dll" ( _
    ByRef xval As double, _
    ByRef fval As double, _
    ByRef der As double, _
    ByRef erest As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D04BBF Lib "NLW32293E_nag.dll" ( _
    ByRef x_0 As double, _
    ByRef hbase As double, _
    ByRef xval As double _
   )


' chapter d05

' skeleton code for callback function
'  Function D05AAF_K1( _
'      ByRef x As double, _
'      ByRef s As double _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function D05AAF_K2( _
'      ByRef x As double, _
'      ByRef s As double _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function D05AAF_G( _
'      ByRef x As double _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub D05AAF Lib "NLW32293E_nag.dll" ( _
    ByRef lambda As double, _
    ByRef a As double, _
    ByRef b As double, _
    ByVal k1 As longPtr, _
    ByVal k2 As longPtr, _
    ByVal g As longPtr, _
    ByRef f As double, _
    ByRef c As double, _
    ByRef n As long, _
    ByRef ind As long, _
    ByRef w1 As double, _
    ByRef w2 As double, _
    ByRef wd As double, _
    ByRef ldw1 As long, _
    ByRef ldw2 As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Function D05ABF_K( _
'      ByRef x As double, _
'      ByRef s As double _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function D05ABF_G( _
'      ByRef x As double _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub D05ABF Lib "NLW32293E_nag.dll" ( _
    ByVal k As longPtr, _
    ByVal g As longPtr, _
    ByRef lambda As double, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef odorev As long, _
    ByRef ev As long, _
    ByRef n As long, _
    ByRef cm As double, _
    ByRef f1 As double, _
    ByRef wk As double, _
    ByRef ldcm As long, _
    ByRef nt2p1 As long, _
    ByRef f As double, _
    ByRef c As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Function D05BAF_CK( _
'      ByRef t As double _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function D05BAF_CG( _
'      ByRef s As double, _
'      ByRef y As double _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function D05BAF_CF( _
'      ByRef t As double _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub D05BAF Lib "NLW32293E_nag.dll" ( _
    ByVal ck As longPtr, _
    ByVal cg As longPtr, _
    ByVal cf As longPtr, _
    ByVal method As string, ByVal methodlength As long, _
    ByRef iorder As long, _
    ByRef alim As double, _
    ByRef tlim As double, _
    ByRef yn As double, _
    ByRef errest As double, _
    ByRef nmesh As long, _
    ByRef tol As double, _
    ByRef thresh As double, _
    ByRef work As double, _
    ByRef lwk As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Function D05BDF_CK( _
'      ByRef t As double _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function D05BDF_CF( _
'      ByRef t As double _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function D05BDF_CG( _
'      ByRef s As double, _
'      ByRef y As double _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub D05BDF Lib "NLW32293E_nag.dll" ( _
    ByVal ck As longPtr, _
    ByVal cf As longPtr, _
    ByVal cg As longPtr, _
    ByVal initwt As string, ByVal initwtlength As long, _
    ByRef iorder As long, _
    ByRef tlim As double, _
    ByRef tolnl As double, _
    ByRef nmesh As long, _
    ByRef yn As double, _
    ByRef work As double, _
    ByRef lwk As long, _
    ByRef nct As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Function D05BEF_CK( _
'      ByRef t As double _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function D05BEF_CF( _
'      ByRef t As double _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function D05BEF_CG( _
'      ByRef s As double, _
'      ByRef y As double _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub D05BEF Lib "NLW32293E_nag.dll" ( _
    ByVal ck As longPtr, _
    ByVal cf As longPtr, _
    ByVal cg As longPtr, _
    ByVal initwt As string, ByVal initwtlength As long, _
    ByRef iorder As long, _
    ByRef tlim As double, _
    ByRef tolnl As double, _
    ByRef nmesh As long, _
    ByRef yn As double, _
    ByRef work As double, _
    ByRef lwk As long, _
    ByRef nct As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D05BWF Lib "NLW32293E_nag.dll" ( _
    ByVal method As string, ByVal methodlength As long, _
    ByRef iorder As long, _
    ByRef omega As double, _
    ByRef nomg As long, _
    ByRef lensw As long, _
    ByRef sw As double, _
    ByRef ldsw As long, _
    ByRef nwt As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D05BYF Lib "NLW32293E_nag.dll" ( _
    ByRef iorder As long, _
    ByRef iq As long, _
    ByRef lenfw As long, _
    ByRef wt As double, _
    ByRef sw As double, _
    ByRef ldsw As long, _
    ByRef work As double, _
    ByRef lwk As long, _
    ByRef ifail As long _
   )


' chapter d06

   Declare Ptrsafe Sub D06AAF Lib "NLW32293E_nag.dll" ( _
    ByRef nvb As long, _
    ByRef nvmax As long, _
    ByRef nedge As long, _
    ByRef edge As long, _
    ByRef nv As long, _
    ByRef nelt As long, _
    ByRef coor As double, _
    ByRef conn As long, _
    ByRef bspace As double, _
    ByRef smooth As long, _
    ByRef coef As double, _
    ByRef power As double, _
    ByRef itrace As long, _
    ByRef rwork As double, _
    ByRef lrwork As long, _
    ByRef iwork As long, _
    ByRef liwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D06ABF Lib "NLW32293E_nag.dll" ( _
    ByRef nvb As long, _
    ByRef nvint As long, _
    ByRef nvmax As long, _
    ByRef nedge As long, _
    ByRef edge As long, _
    ByRef nv As long, _
    ByRef nelt As long, _
    ByRef coor As double, _
    ByRef conn As long, _
    ByRef weight As double, _
    ByRef npropa As long, _
    ByRef itrace As long, _
    ByRef rwork As double, _
    ByRef lrwork As long, _
    ByRef iwork As long, _
    ByRef liwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D06ACF Lib "NLW32293E_nag.dll" ( _
    ByRef nvb As long, _
    ByRef nvint As long, _
    ByRef nvmax As long, _
    ByRef nedge As long, _
    ByRef edge As long, _
    ByRef nv As long, _
    ByRef nelt As long, _
    ByRef coor As double, _
    ByRef conn As long, _
    ByRef weight As double, _
    ByRef itrace As long, _
    ByRef rwork As double, _
    ByRef lrwork As long, _
    ByRef iwork As long, _
    ByRef liwork As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Function D06BAF_FBND( _
'      ByRef i As long, _
'      ByRef x As double, _
'      ByRef y As double, _
'      ByVal ruser_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Function D06BAD Lib "NLW32293E_nag.dll" ( _
    ByRef i As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByVal ruser_rptr As longPtr, _
    ByVal iuser_iptr As longPtr _
  ) As double

   Declare Ptrsafe Sub D06BAF Lib "NLW32293E_nag.dll" ( _
    ByRef nlines As long, ByRef coorch As double, ByRef lined As long, _
    ByVal fbnd As longPtr, ByRef crus As double, ByRef sdcrus As long, _
    ByRef rate As double, ByRef ncomp As long, ByRef nlcomp As long, _
    ByRef lcomp As long, ByRef nvmax As long, ByRef nedmx As long, _
    ByRef nvb As long, ByRef coor As double, ByRef nedge As long, _
    ByRef edge As long, ByRef itrace As long, ByRef ruser As double, _
    ByRef iuser As long, ByRef rwork As double, ByRef lrwork As long, _
    ByRef iwork As long, ByRef liwork As long, ByRef ifail As long _
   )


   Declare Ptrsafe Sub D06CAF Lib "NLW32293E_nag.dll" ( _
    ByRef nv As long, _
    ByRef nelt As long, _
    ByRef nedge As long, _
    ByRef coor As double, _
    ByRef edge As long, _
    ByRef conn As long, _
    ByRef nvfix As long, _
    ByRef numfix As long, _
    ByRef itrace As long, _
    ByRef nqint As long, _
    ByRef iwork As long, _
    ByRef liwork As long, _
    ByRef rwork As double, _
    ByRef lrwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D06CBF Lib "NLW32293E_nag.dll" ( _
    ByRef nv As long, _
    ByRef nelt As long, _
    ByRef nnzmax As long, _
    ByRef conn As long, _
    ByRef nnz As long, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D06CCF Lib "NLW32293E_nag.dll" ( _
    ByRef nv As long, _
    ByRef nelt As long, _
    ByRef nedge As long, _
    ByRef nnzmax As long, _
    ByRef nnz As long, _
    ByRef coor As double, _
    ByRef edge As long, _
    ByRef conn As long, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByRef itrace As long, _
    ByRef iwork As long, _
    ByRef liwork As long, _
    ByRef rwork As double, _
    ByRef lrwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D06DAF Lib "NLW32293E_nag.dll" ( _
    ByRef nv As long, _
    ByRef nedge As long, _
    ByRef nelt As long, _
    ByRef ntrans As long, _
    ByRef itype As long, _
    ByRef trans As double, _
    ByRef coori As double, _
    ByRef edgei As long, _
    ByRef conni As long, _
    ByRef cooro As double, _
    ByRef edgeo As long, _
    ByRef conno As long, _
    ByRef itrace As long, _
    ByRef rwork As double, _
    ByRef lrwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub D06DBF Lib "NLW32293E_nag.dll" ( _
    ByRef eps As double, ByRef nv1 As long, ByRef nelt1 As long, _
    ByRef nedge1 As long, ByRef coor1 As double, ByRef edge1 As long, _
    ByRef conn1 As long, ByRef reft1 As long, ByRef nv2 As long, _
    ByRef nelt2 As long, ByRef nedge2 As long, ByRef coor2 As double, _
    ByRef edge2 As long, ByRef conn2 As long, ByRef reft2 As long, _
    ByRef nv3 As long, ByRef nelt3 As long, ByRef nedge3 As long, _
    ByRef coor3 As double, ByRef edge3 As long, ByRef conn3 As long, _
    ByRef reft3 As long, ByRef itrace As long, ByRef iwork As long, _
    ByRef liwork As long, ByRef ifail As long _
   )


